;* ======================================================= *
;*                     COUNTRY.ASM                         *
;*           (C) 1993 Heinz Klaus & DMV-Verlag             *
;* ======================================================= *
;* Feststellung der aktuellen Lndereinstellung und Ver-   *
;* schiebung der jeweiligen Landestexte in den verblei-    *
;* benden Programmteil. Programmgerst fr weitere         *
;* Programmentwickungen.                                   *
;* ======================================================= *
;*   Assemblieren :  TASM country | TLINK /T country       *
;*   Aufruf       :  country  [Landescode]                 *
;* ======================================================= *
.8086
.MODEL TINY

        LOCALS  @@          ;* Labelkollisionen vermeiden

CODE    SEGMENT PARA 'CODE' ;* Codesegment definieren
        ORG  100H           ;* Programmstart bei 100h
        ASSUME CS: CODE, DS: CODE, ES: CODE, SS: CODE

Start:  JMP  Init           ;* Sprung zur Init-Routine

;* Ab hier steht Ihr Hauptprogramm inklusive Unterprogramme:
Prog    PROC NEAR           ;* Demo mit Textausgabe
                            ;* via DOS-Interrupt 21h
        MOV  AH, 9          ;* Funktion 09h
        MOV  DX, Msg1       ;* Ausgabe:  Textteil 1
        INT  21H
        MOV  DX, Msg2       ;* Ausgabe:  Textteil 2
        INT  21H
        MOV  DX, Msg3       ;* Ausgabe:  Textteil 3
        INT  21H
        MOV  DX, Msg4       ;* Ausgabe:  Textteil 4
        INT  21H
        XOR  AH, AH         ;* auf einen Tastendruck
        INT  16H            ;* warten und ...
        MOV  AX, 4C00H      ;* ... danach das Programm
        INT  21H            ;* beenden.
Prog    ENDP                ;* Ende des Demoprogramms

;* Daten:

;* ======================================================= *
;* hier knnen Sie Ihre gesamten Daten, Puffer und         *
;* Variablen anlegen, die Ihr Programm bentigt ...        *
;* ======================================================= *

;* ======================================================= *
;* hier stehen die Text-Label, der Textpuffer und der      *
;* Stackbereich:                                           *

Strg_E  DB '$'              ;* Endezeichen fr die DOS-
                            ;* Strings. Fr BIOS-Strings mu
                            ;* hier eine Null stehen

Msg1    DW  0         ;* Label des Textes 1 (Zeiger auf die)
Msg2    DW  0         ;* Label des Textes 2 (Adresse inner-)
Msg3    DW  0         ;* Label des Textes 3 (halb des Text-)
Msg4    DW  0         ;* Label des Textes 4 (puffers.      )
                      ;* usw...

Msg_Buf DB  200 DUP (?)     ;* Textpuffer fr den jeweiligen
                            ;* Textteil: deutsch, englisch,
                            ;* franzsisch ... 
Cou_Buf DB   34 DUP (?)     ;* Puffer fr die landesspezifi-
                            ;* schen Daten (Daten siehe DOS-
                            ;* Interrupt 21h/Fkt.38h)
P_Stack DB  512 DUP (?)     ;* der Stackbereich (hier 512
                            ;* Bytes gro) mu Ihrem Bedarf
                            ;* angepat werden!...
Prog_E  EQU THIS BYTE       ;* ACHTUNG! Ab hier wird der
                            ;* Speicher (nach der Initiali-
                            ;* sierung) freigegeben

;* hier stehen Ihre Texte in der jeweiligen Landessprache:

CRLF    EQU 13, 10

Msg_G   DB CRLF, 'msg1 = Sprechen Sie deutsch?', CRLF
        DB 39 DUP ('-'), '$'
        DB CRLF, 'msg2 = Dies ist die zweite Meldung!$'
        DB CRLF, 'msg3 = Und dies ist die dritte Meldung!'
        DB CRLF, '$'
        DB CRLF, 'msg4 = Bettigen Sie eine Taste!'
        DB CRLF, '$'
                ;* Lnge des deutschen Textblocks berechnen:
Len_G   EQU  $ - Msg_G    

Msg_F   DB CRLF, 'msg1 = Parlez-vous franais?', CRLF
        DB 39 DUP ('-'), '$'
        DB CRLF, "msg2 = C'est la deuxime nouvelle!$"
        DB CRLF, "msg3 = Et c'est la troisime nouvelle!"
        DB CRLF, '$'
        DB CRLF, 'msg4 = Frappez une touche! ', CRLF, '$'
            ;* Lnge des franzsischen Textblocks berechnen:
Len_F   EQU  $ - Msg_F    

Msg_E   DB CRLF, 'msg1 = Do you speak English?', CRLF
        DB 39 DUP ('-'), '$'
        DB CRLF, 'msg2 = This is the second message!$'
        DB CRLF, 'msg3 = And this is the third message!'
        DB CRLF, '$'
        DB CRLF, 'msg4 = Press any key! ', CRLF, '$'
               ;* Lnge des englischen Textblocks berechnen:
Len_E   EQU  $ - Msg_E

;* ======================================================= *
;* hier knnen noch weitere Sprachen/Texte sein!           *
;* ======================================================= *

;* ======================================================= *
;* hier knnen Sie Variablen, Puffer usw. ansiedeln, die   *
;* nach der Initialisierung nicht mehr bentigt werden!    *
;* ======================================================= *

;* Initialisierungsroutine:

Init    PROC NEAR
        MOV  AX, CS         ;* Segmentadresse nach DS und ES
        MOV  DS, AX         ;* laden, wegen der String-
        MOV  ES, AX         ;* befehle LODSB und STOSB
        CALL ComLine        ;* Kommandozeilen-Parameter 
                            ;* holen (Demo)
        CALL Country        ;* Landessprache einstellen /
                            ;* kopieren

;* ======================================================= *
;* hier knnten Sie noch weitere Initialisierungs-Routinen *
;* aufrufen bzw. einbauen!                                 *
;* ======================================================= *

;* Nicht mehr bentigten Speicher freigeben
;* (ab Label prog_e)

;*  ACHTUNG!  mu die letzte Routine innerhalb der Init-
;*            Prozedur sein!

        MOV  AH, 4AH        ;* Fkt-Nr. fr Speichergre
                            ;* ndern
        LEA  BX, Prog_E     ;* Anzahl der Paragraphen
                            ;* (je 16 Byte), ber die das
        MOV  CL, 4          ;* Programm verfgen soll,
        SHR  BX, CL         ;* berechnen zur Sicherheit
        INC  BX             ;* einen Paragraph dazugeben und
        INT  21H            ;* den DOS-Interrupt aufrufen
        LEA  SP, Prog_E     ;* Stackpointer setzen
                            ;* (neue Adresse!)

;* und erst jetzt springen wir zum eigentlichen Programm:
        JMP  Prog           ;* und ab ins Hauptprogramm ...

Init    ENDP                ;* Ende der Initialisierung.


;* ======================================================= *
;* Kommandozeilenparameter holen und ASCII-Wert nach binr *
;* umwandeln (Achtung! wurde nur fr dieses Demoprogramm   *
;* konzipiert)                                             *
ComLine PROC NEAR
        XOR  CH, CH         ;* Highbyte von CX auf 0 setzen
        MOV  SI, 80H        ;* PSP-Adresse/Anzahl Parameter
        MOV  CL, BYTE PTR [SI] ;* Anzahl der Parameter laden
        JCXZ @@3            ;* wenn NULL, dann raus....
        MOV  DI, 10         ;* fr die Rechnung im Dez-Syst.
        XOR  BH, BH         ;* Highbyte von BX auf 0 setzen
        XOR  AX, AX         ;* AX auf Null setzen
@@1:    INC  SI             ;* PSP-Adresse erhhen
        MOV  BL, BYTE PTR [SI] ;* Zeichen aus Kommandozeile
        CMP  BL, 21H        ;* Leerzeichen/Tabulator?
        JB   @@2            ;*   wenn JA, dann weiter
        CMP  BL, 30H        ;* ist das Zeichen eine Ziffer?
        JB   @@3            ;*   wenn NEIN, dann raus...
        CMP  BL, 39H        ;* ist das Zeichen eine Ziffer?
        JA   @@3            ;*   wenn NEIN, dann raus...
        MUL  DI             ;* bisher errechnete Zahl * 10
        JC   @@3            ;* Zahl > 65535?
                            ;*   wenn JA, Fehler! ...
        AND  BL, 15         ;* Ziffer nach binr umwandeln
        ADD  AX, BX         ;* und zum bisherigen Ergebnis
                            ;* addieren
@@2:    LOOP @@1            ;* Schleife bis CX=0 durchlaufen
        XCHG AX, BX         ;* alles OK / Carry-Flag ist
                            ;* gelscht und in BX steht der
        RET                 ;* Landescode ...
@@3:    STC                 ;* kein bzw. ungltig. Parameter
        RET                 ;* daher Carry-Flag setzen
ComLine ENDP

;* ======================================================= *
;* Initialisierungsroutine fr die jeweilige Landessprache *
Country PROC NEAR
         JNC  @@0           ;* gltige Kommandozeile?, wenn
                            ;* JA, dann keine DOS-Abfrage ..

;* aktuelle Landeseinstellung via DOS (ab 3.0) holen ...

        LEA  DX, Cou_Buf    ;* Pufferadresse fr die
                            ;* landesspezifischen Daten
        MOV  AX, 3800H      ;* via DOS Interrupt 21h /
                            ;* Funktion 3800h die aktuelle
        INT  21H            ;* Lndereinstellung holen,
                            ;* in BX steht der aktuelle
                            ;* Lndercode!

;* ... und entsprechende Textadresse / Textblocklnge laden:

@@0:    LEA  SI, Msg_G      ;* Adresse des deutschen
        MOV  CX, Len_G      ;* Textblocks und seine Gesamt-
                            ;* lnge laden
        CMP  BX, 49         ;* Landescode Deutschland?
        JE   @@1            ;* wenn JA, dann zur Kopier-
                            ;* Routine ...
        CMP  BX, 43         ;* Landescode sterreich?
        JE   @@1            ;* wenn JA, dann zur Kopier-
                            ;* Routine ...
        CMP  BX, 41         ;* Landescode Schweiz?
        JE   @@1            ;* wenn JA, dann zur Kopier-
                            ;* Routine....
        LEA  SI, Msg_F      ;* Adresse des franzsischen
                            ;* Textblocks
        MOV  CX, Len_F      ;* und seine Gesamtlnge laden
        CMP  BX, 33         ;* Landescode Frankreich?
        JE   @@1            ;* wenn JA, dann zur Kopier-
                            ;* Routine....
        LEA  SI, Msg_E      ;* englische oder unbekannte
        MOV  CX, Len_E      ;* Landescodeangabe, daher
                            ;* englische Sprache!
@@1:    LEA  DI, Msg_Buf    ;* Textpufferadresse laden und
        MOV  [Msg1], DI     ;* sie dem ersten Textlabel
                            ;* bergeben
;* Kopierroutine / verschiebt die Landestexte in den Puffer
        XOR  BX, BX         ;* BX auf Null setzen/wegen der
                            ;* Adressierung
        CLD                 ;* Directionflag lschen
@@2:    LODSB               ;* erstes Zeichen der Landes-
        STOSB               ;* sprache holen und im
                            ;* Textpuffer ablegen
        DEC  CX             ;* Textlnge -1
        JCXZ @@3            ;* Textlnge schon 0, dann raus!
        CMP  AL, Strg_E     ;* Stringende-Zeichen entdeckt?
        JNE  @@2            ;* wenn NEIN, weiter
        INC  BX             ;* Zeichen entdeckt, daher die
        INC  BX             ;* Adresse des nchst. Textlabel
        MOV  [Msg1+BX], DI  ;* berechnen und Adresse (inner-
                            ;* halb des Puffer) bergeben
        JMP  SHORT @@2      ;* weiter in der Schleife
                            ;* bis CX=0
@@3:    RET
Country ENDP

;* ======================================================= *
;*  hier knnen Sie noch weitere Routinen ansiedeln, die   *
;*  nach der Initialisierung nicht mehr bentigt werden.   *
;*  z.B  Dos-Version, Systemdateien, Grafikkarte usw.      *
;* ======================================================= *

CODE    ENDS                ;* Ende des CODE-Segments
        END  Start          ;* Ende des Assembler-Programms

;* ======================================================= *
;*                Ende von COUNTRY.ASM                     *
