/* ------------------------------------------------- */
/*                    ICOCON.H                       */
/*   Zusammengefate Header-Datei fr die Dateien    */
/*           ICOCON.C, FILE.C und ICON.C             */
/*                                                   */
/*          (C) 1993 Kay Glahn & DMV-Verlag          */
/* ------------------------------------------------- */

typedef struct tagICONFILEHEADER
{
  WORD icoReserved;
  WORD icoResourceType;
  WORD icoResourceCount;
}
ICONFILEHEADER;

typedef ICONFILEHEADER FAR *LPICONFILEHEADER;

typedef struct tagICONRESOURCE
{
  BYTE Width;
  BYTE Height;
  BYTE ColorCount;
  BYTE Reserved1;
  WORD Reserved2;
  WORD Reserved3;
  DWORD icoDIBSize;
  DWORD icoDIBOffset;
}
ICONRESOURCE;

typedef ICONRESOURCE FAR *LPICONRESOURCE;


typedef struct tagBITMAPARRAYFILEHEADER2
{
  WORD usType;
  DWORD cbSize;
  DWORD offNext;
  WORD cxDisplay;
  WORD cyDisplay;
}
BITMAPARRAYFILEHEADER2;

typedef BITMAPARRAYFILEHEADER2 FAR *LPBITMAPARRAYFILEHEADER2;

typedef struct tagBITMAPFILEHEADER2
{
  WORD usType;
  DWORD cbSize;
  WORD xHotspot;
  WORD yHotspot;
  DWORD offBits;
}
BITMAPFILEHEADER2;

typedef BITMAPFILEHEADER2 FAR *LPBITMAPFILEHEADER2;

typedef struct tagBITMAPCOREHEADER2
{
  DWORD cbFix;
  DWORD cx;
  DWORD cy;
  WORD cPlanes;
  WORD cBitCount;
  DWORD ulCompression;
  DWORD cbImage;
  DWORD cxResolution;
  DWORD cyResolution;
  DWORD cclrUsed;
  DWORD cclrImportant;
  WORD usUnits;
  WORD usReserved;
  WORD usRecording;
  WORD usRendering;
  DWORD cSize1;
  DWORD cSize2;
  DWORD ulColorEncoding;
  DWORD ulIdentifier;
}
BITMAPCOREHEADER2;

typedef BITMAPCOREHEADER2 FAR* LPBITMAPCOREHADER2;

typedef struct tagBITMAPCOREINFO2
{
  BITMAPCOREHEADER2 bmciHeader;
  RGBQUAD bmciColors[];
}
BITMAPCOREINFO2;

typedef BITMAPCOREINFO2 FAR* LPBITMAPCOREINFO2;

#define ID_FILE1      100
#define ID_FILE2      101
#define ID_LISTBOX1   102
#define ID_LISTBOX2   103
#define ID_COPY       104
#define ID_DELETE     105
#define ID_NEW1       107
#define ID_OPEN1      108
#define ID_SAVE1      109
#define ID_NEW2       114
#define ID_OPEN2      115
#define ID_SAVE2      116
#define ID_ICON       111
#define ID_FRAME      113
#define ID_END        112

#define IDC_ABOUT     200
#define IDC_HELP      201

#define ID_HELPTEXT   300
#define ID_SCROLL     301
#define ID_PAGETEXT   302

#define IDC_FILENAME  500
#define IDC_EDIT      501
#define IDC_FILES     502
#define IDC_PATH      503
#define IDC_LISTBOX   504
#define IDC_RADIO1    505
#define IDC_RADIO2    506
#define IDC_RADIO3    507

#define NUM_HELPTEXT  9

int PASCAL WinMain(HANDLE, HANDLE, LPSTR, int);
int FAR PASCAL WinDlg(HWND, WORD, WORD, DWORD);
BOOL FAR PASCAL About(HWND, unsigned, WORD, LONG);
void CenterWnd(HWND, HWND);
BOOL ShowIcon(HDC, int, int);
void ShowFileName(LPSTR);
void GetPosition(PWORD, PWORD);
BOOL FAR PASCAL HelpDlg(HWND, unsigned, WORD, LONG);
void Command(WORD, DWORD);

HANDLE FAR PASCAL OpenDlg(HWND, unsigned, WORD, LONG);
void UpdateListBox(HWND);
void ChangeDefExt(PSTR, PSTR);
void SeparateFile(HWND, LPSTR, LPSTR, LPSTR);
void AddExt(PSTR, PSTR);
int FAR PASCAL SaveAsDlg(HWND, unsigned, WORD, LONG);
BOOL CheckFileName(HWND, PSTR, PSTR);
BOOL QuerySaveFile(HWND,HANDLE,HANDLE,HANDLE,HANDLE,int,LPSTR,BOOL FAR*, BOOL);

BOOL SaveIconFile(HANDLE FAR*,HANDLE FAR*,HANDLE FAR*,HANDLE FAR*,HANDLE, HWND, WORD);
DWORD SaveIcon(HBITMAP,HBITMAP,HPALETTE,DWORD,WORD,HWND,WORD);
BOOL RetrieveIcon(HBITMAP FAR*,HBITMAP FAR*,HPALETTE FAR*,DWORD,int,HWND);
BOOL RetrieveIconFile(HANDLE FAR*,HANDLE FAR*,HANDLE FAR*,HANDLE FAR*,HANDLE,HWND, WORD FAR*);
BOOL RetrieveIcon2(HBITMAP FAR*,HBITMAP FAR*,HPALETTE FAR*,ICONRESOURCE FAR*,DWORD,DWORD,DWORD,DWORD,int,HWND,BOOL);
BOOL RetrieveIconFile2(HANDLE FAR*,HANDLE FAR*,HANDLE FAR*,HANDLE FAR*,HANDLE,HWND, WORD FAR*, BOOL FAR*);
BOOL DelIcon(HANDLE FAR*,HANDLE FAR*,HANDLE FAR*,HANDLE FAR*,WORD FAR*,HWND,int);
BOOL DelAllIcons(HANDLE FAR*,HANDLE FAR*,HANDLE FAR*,HANDLE FAR*,WORD FAR*,HWND);
BYTE ColBit(int);
int BitCol(BYTE);
BOOL CopyIcon(HBITMAP FAR **, HBITMAP FAR **, HPALETTE FAR **, ICONRESOURCE FAR **, int, int, int, HWND);
DWORD SaveIcon2(HBITMAP,HBITMAP,HPALETTE,DWORD,DWORD,DWORD,DWORD,WORD,HWND,WORD, BOOL);
BOOL SaveIconFile2(HANDLE FAR*,HANDLE FAR*,HANDLE FAR*,HANDLE FAR*,HANDLE, HWND, WORD, BOOL);
WORD CheckFileType(int);
DWORD CalcSize(WORD, WORD, WORD);

/* ------------------------------------------------- */
/*                 Ende von ICOCON.H                 */
