/* ------------------------------------------------- */
/*                       ICON.C                      */
/*   Routinen zum Laden, Speichern und Bearbeiten    */
/*  von Windows- und OS2 1.x und 2.x -Icon-Dateien   */
/*                                                   */
/*           (C) 1993 Kay Glahn & DMV-Verlag         */
/* ------------------------------------------------- */

#include <windows.h>
#include "ICOCON.h"


int                      Mode;

extern char              str[255];

extern int               i,
			 CurrIcon;

extern HANDLE            hInst;


RetrieveIcon(lphXORBitmap,lphANDBitmap,lphPal,BegPos,hFile,hWnd)
HBITMAP FAR *lphXORBitmap;
HBITMAP FAR *lphANDBitmap;
HPALETTE FAR *lphPal;
DWORD BegPos;
int hFile;
HWND hWnd;
{
  HDC hDC;
  DWORD Size;
  DWORD Groesse;
  DWORD Size1;
  WORD PalEntrys;
  BITMAPINFO Bitmapinfo;
  LPBITMAPINFO lpBitmapinfo;
  LPSTR lpMem;
  HANDLE hBitmapinfoMem;
  HANDLE hMem;
  int count;
  int i;
  RGBQUAD FAR *pRgb;
  LOGPALETTE *pPal;
  WORD FAR *pw;

  _llseek(hFile,BegPos,0);
  count = _lread(hFile,(LPSTR)&Bitmapinfo.bmiHeader,sizeof(BITMAPINFOHEADER));
  Bitmapinfo.bmiHeader.biHeight/=2;
  PalEntrys = Bitmapinfo.bmiHeader.biClrUsed;

  if(PalEntrys == 0)
  {
    switch(Bitmapinfo.bmiHeader.biBitCount)
    {
      case 1:
	PalEntrys = 2;
	break;
      case 4:
	PalEntrys = 16;
	break;
      case 8:
	PalEntrys = 256;
	break;
    }
  }

  if ((PalEntrys!=2)&&(PalEntrys!=16)&&(PalEntrys!=256))
  {
    MessageBox(hWnd, "Die gewhlte Datei ist keine gltige Icon-Datei, Ladevorgang wird abgebrochen !" ,NULL,MB_OK|MB_ICONHAND);
    return(FALSE);
  }

  Groesse = sizeof(BITMAPINFOHEADER)+PalEntrys*sizeof(RGBQUAD);
  Size = CalcSize((WORD)Bitmapinfo.bmiHeader.biWidth, (WORD)Bitmapinfo.bmiHeader.biHeight, Bitmapinfo.bmiHeader.biBitCount);

  if ((hBitmapinfoMem = GlobalAlloc(GMEM_MOVEABLE,Groesse)) != NULL)
  {
    if ((hMem = GlobalAlloc(GMEM_MOVEABLE,Size)) != NULL)
    {
      if((lpBitmapinfo = (LPBITMAPINFO)GlobalLock(hBitmapinfoMem)) != NULL)
      {
	if((lpMem = GlobalLock(hMem)) != (LPSTR) NULL)
	{
	  _llseek(hFile,BegPos,0);
	  count = _lread(hFile,(LPSTR)lpBitmapinfo,(WORD)Groesse);
	  _llseek(hFile,BegPos+count,0);
	  count= _lread(hFile,(LPSTR)lpMem, (WORD)Size);

	  hDC = GetDC(NULL);

	  lpBitmapinfo->bmiHeader.biHeight /=2;
	  pRgb = (RGBQUAD FAR *)((LPSTR)lpBitmapinfo->bmiColors);
	  pPal = (LOGPALETTE*)LocalAlloc(LPTR,sizeof(LOGPALETTE) + PalEntrys * sizeof(PALETTEENTRY));

	  if (!pPal)
	    return FALSE;

	  pPal->palNumEntries = PalEntrys;
	  pPal->palVersion    = 0x300;

	  for (i = 0; i < PalEntrys; i++)
	  {
	    pPal->palPalEntry[i].peRed   = pRgb[i].rgbRed;
	    pPal->palPalEntry[i].peGreen = pRgb[i].rgbGreen;
	    pPal->palPalEntry[i].peBlue  = pRgb[i].rgbBlue;
	    pPal->palPalEntry[i].peFlags = (BYTE)0;
	  }

	  *lphPal = CreatePalette(pPal);
	  LocalFree((HANDLE)pPal);
	  pw = (WORD FAR *)((LPSTR)lpBitmapinfo->bmiColors);

	  for (i=0; i<(int)PalEntrys; i++)
	    *pw++ = (WORD)i;

	  if (*lphPal)
	  {
	    SelectPalette(hDC,*lphPal,FALSE);
	    RealizePalette(hDC);
	  }

	  *lphXORBitmap=CreateDIBitmap(hDC,(LPBITMAPINFOHEADER)&(lpBitmapinfo->bmiHeader),CBM_INIT,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapinfo,DIB_PAL_COLORS);
	  ReleaseDC(NULL,hDC);
	  GlobalUnlock(hMem);
	  GlobalFree(hMem);
	  GlobalUnlock(hBitmapinfoMem);
	  GlobalFree(hBitmapinfoMem);
	  if (*lphXORBitmap)
	  {
	    Size1=CalcSize((WORD)Bitmapinfo.bmiHeader.biWidth, (WORD)Bitmapinfo.bmiHeader.biHeight, 1);

	    if ((hMem = GlobalAlloc(GMEM_MOVEABLE,Size1)) != NULL)
	    {
	      if ((hBitmapinfoMem = GlobalAlloc(GMEM_MOVEABLE,sizeof(BITMAPINFOHEADER)+2*sizeof(RGBQUAD))) != NULL)
	      {
		if((lpMem = GlobalLock(hMem)) != (LPSTR) NULL)
		{
		  if((lpBitmapinfo = (LPBITMAPINFO)GlobalLock(hBitmapinfoMem)) != NULL)
		  {
		    lpBitmapinfo->bmiHeader.biSize=(long)sizeof(BITMAPINFOHEADER);
		    lpBitmapinfo->bmiHeader.biWidth=Bitmapinfo.bmiHeader.biWidth;
		    lpBitmapinfo->bmiHeader.biHeight=Bitmapinfo.bmiHeader.biHeight;
		    lpBitmapinfo->bmiHeader.biPlanes=1;
		    lpBitmapinfo->bmiHeader.biBitCount=1;
		    lpBitmapinfo->bmiHeader.biCompression=0L;
		    lpBitmapinfo->bmiHeader.biSizeImage=0L;
		    lpBitmapinfo->bmiHeader.biXPelsPerMeter=0L;
		    lpBitmapinfo->bmiHeader.biYPelsPerMeter=0L;
		    lpBitmapinfo->bmiHeader.biClrUsed=0L;
		    lpBitmapinfo->bmiHeader.biClrImportant=0L;
		    lpBitmapinfo->bmiColors[0].rgbRed=0;
		    lpBitmapinfo->bmiColors[0].rgbGreen=0;
		    lpBitmapinfo->bmiColors[0].rgbBlue=0;
		    lpBitmapinfo->bmiColors[1].rgbRed=0xff;
		    lpBitmapinfo->bmiColors[1].rgbGreen=0xff;
		    lpBitmapinfo->bmiColors[1].rgbBlue=0xff;

		    hDC=GetDC(NULL);

		    _llseek(hFile,BegPos+Groesse+Size,0);
		    count=_lread(hFile,(LPSTR)lpMem,(WORD)Size1);

		    *lphANDBitmap = CreateDIBitmap(hDC,(LPBITMAPINFOHEADER)&(lpBitmapinfo->bmiHeader),CBM_INIT,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapinfo, DIB_RGB_COLORS);
		    ReleaseDC(NULL,hDC);
		    GlobalUnlock(hBitmapinfoMem);
		    GlobalUnlock(hMem);
		    GlobalFree(hBitmapinfoMem);
		    GlobalFree(hMem);
		  }
		}
	      }
	    }
	  }
	  else
	  {
	    MessageBox(hWnd, "Bitmap konnte nicht erstellt werden !" ,NULL,MB_OK|MB_ICONHAND);
	    return FALSE;
	  }
	}
      }
    }
  }
  return TRUE;
}

DWORD SaveIcon(hXORBitmap, hANDBitmap, hPal, BegPos, hFile, hWnd, BitPix)
HBITMAP hXORBitmap;
HBITMAP hANDBitmap;
HPALETTE hPal;
DWORD BegPos;
WORD hFile;
HWND hWnd;
WORD BitPix;
{

  HDC hDC;
  DWORD Size;
  DWORD Groesse;
  DWORD Size1;
  LPBITMAPINFO lpBitmapinfo;
  LPSTR lpMem;
  HANDLE hBitmapinfoMem;
  HANDLE hMem;
  int count;
  WORD PalEntrys;
  BITMAP Bitmap;

  GetObject(hXORBitmap,sizeof(BITMAP),(LPSTR)&Bitmap);
  GetObject(hPal,2,(LPSTR)&PalEntrys);
  Groesse = sizeof(BITMAPINFOHEADER)+PalEntrys*sizeof(RGBQUAD);

  if ((hBitmapinfoMem = GlobalAlloc(GMEM_MOVEABLE,Groesse)) != NULL)
  {
    if((lpBitmapinfo = (LPBITMAPINFO)GlobalLock(hBitmapinfoMem)) != NULL)
    {
      lpBitmapinfo->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
      lpBitmapinfo->bmiHeader.biWidth = Bitmap.bmWidth;
      lpBitmapinfo->bmiHeader.biHeight = Bitmap.bmHeight;
      lpBitmapinfo->bmiHeader.biPlanes = 1;
      lpBitmapinfo->bmiHeader.biBitCount = BitPix;
      lpBitmapinfo->bmiHeader.biCompression = 0;
      lpBitmapinfo->bmiHeader.biSizeImage = 0;
      lpBitmapinfo->bmiHeader.biXPelsPerMeter = 0;
      lpBitmapinfo->bmiHeader.biYPelsPerMeter = 0;
      lpBitmapinfo->bmiHeader.biClrUsed = 0;
      lpBitmapinfo->bmiHeader.biClrImportant = 0;

      hDC=GetDC(NULL);

      SelectPalette(hDC,hPal,0);
      RealizePalette(hDC);
      GetDIBits(hDC,hXORBitmap,0,(WORD)lpBitmapinfo->bmiHeader.biHeight,NULL,(LPBITMAPINFO)lpBitmapinfo,DIB_RGB_COLORS);

      Size = CalcSize((WORD)lpBitmapinfo->bmiHeader.biWidth, (WORD)lpBitmapinfo->bmiHeader.biHeight, lpBitmapinfo->bmiHeader.biBitCount);

      if ((hMem = GlobalAlloc(GMEM_MOVEABLE,Size)) != NULL)
      {
	if((lpMem = GlobalLock(hMem)) != (LPSTR) NULL)
	{
	  count = GetDIBits(hDC,hXORBitmap,0,(WORD)lpBitmapinfo->bmiHeader.biHeight,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapinfo,DIB_RGB_COLORS);
	  ReleaseDC(NULL,hDC);

	  Size1=CalcSize((WORD)lpBitmapinfo->bmiHeader.biWidth, (WORD)lpBitmapinfo->bmiHeader.biHeight, 1);

	  lpBitmapinfo->bmiHeader.biSizeImage += Size1;
	  lpBitmapinfo->bmiHeader.biHeight*=2;
	  _llseek(hFile,BegPos,0);

	  if((count=_lwrite(hFile,(LPSTR)lpBitmapinfo,(WORD)Groesse))!=Groesse)
	  {
	    MessageBox(hWnd,"Nicht gengend freier Speicher auf Laufwerk!",NULL,MB_OK|MB_ICONHAND);
	    GlobalUnlock(hMem);
	    GlobalFree(hMem);
	    GlobalUnlock(hBitmapinfoMem);
	    GlobalFree(hBitmapinfoMem);
	    return(FALSE);
	  }

	  _llseek(hFile,BegPos+Groesse,0);

	  if((count=_lwrite(hFile,lpMem,(WORD)Size))!=Size)
	  {
	    MessageBox(hWnd,"Nicht gengend freier Speicher auf Laufwerk!",NULL,MB_OK|MB_ICONHAND);
	    GlobalUnlock(hMem);
	    GlobalFree(hMem);
	    GlobalUnlock(hBitmapinfoMem);
	    GlobalFree(hBitmapinfoMem);
	    return(FALSE);
	  }

	  GlobalUnlock(hMem);
	  GlobalFree(hMem);
	  GlobalUnlock(hBitmapinfoMem);
	  GlobalFree(hBitmapinfoMem);
	  GetObject(hXORBitmap,sizeof(BITMAP),(LPSTR)&Bitmap);

	  Size1=CalcSize(Bitmap.bmWidth, Bitmap.bmHeight, 1);

	  if ((hMem = GlobalAlloc(GMEM_MOVEABLE,Size1)) != NULL)
	  {
	    if((lpMem = GlobalLock(hMem)) != (LPSTR) NULL)
	    {
	      if ((hBitmapinfoMem = GlobalAlloc(GMEM_MOVEABLE,sizeof(BITMAPINFOHEADER)+2*sizeof(RGBQUAD))) != NULL)
	      {
		if((lpBitmapinfo = (LPBITMAPINFO)GlobalLock(hBitmapinfoMem)) != NULL)
		{
		  lpBitmapinfo->bmiHeader.biSize=(long)sizeof(BITMAPINFOHEADER);
		  lpBitmapinfo->bmiHeader.biWidth=Bitmap.bmWidth;
		  lpBitmapinfo->bmiHeader.biHeight=Bitmap.bmHeight;
		  lpBitmapinfo->bmiHeader.biPlanes=1;
		  lpBitmapinfo->bmiHeader.biBitCount=1;
		  lpBitmapinfo->bmiHeader.biCompression=0L;
		  lpBitmapinfo->bmiHeader.biSizeImage=0L;
		  lpBitmapinfo->bmiHeader.biXPelsPerMeter=0L;
		  lpBitmapinfo->bmiHeader.biYPelsPerMeter=0L;
		  lpBitmapinfo->bmiHeader.biClrUsed=0L;
		  lpBitmapinfo->bmiHeader.biClrImportant=0L;
		  lpBitmapinfo->bmiColors[0].rgbRed=0;
		  lpBitmapinfo->bmiColors[0].rgbGreen=0;
		  lpBitmapinfo->bmiColors[0].rgbBlue=0;
		  lpBitmapinfo->bmiColors[1].rgbRed=0xff;
		  lpBitmapinfo->bmiColors[1].rgbGreen=0xff;
		  lpBitmapinfo->bmiColors[1].rgbBlue=0xff;

		  hDC=GetDC(NULL);

		  count = GetDIBits(hDC,hANDBitmap,0,(WORD)lpBitmapinfo->bmiHeader.biHeight,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapinfo,DIB_RGB_COLORS);

		  ReleaseDC(NULL,hDC);

		  _llseek(hFile,BegPos+Groesse+Size,0);

		  if((count=_lwrite(hFile,(LPSTR)lpMem,(WORD)Size1))!=Size1)
		  {
		    MessageBox(hWnd,"Nicht gengend freier Speicher auf Laufwerk!",NULL,MB_OK|MB_ICONHAND);
		    GlobalUnlock(hBitmapinfoMem);
		    GlobalUnlock(hMem);
		    GlobalFree(hBitmapinfoMem);
		    GlobalFree(hMem);
		    return (FALSE);
		  }

		  GlobalUnlock(hBitmapinfoMem);
		  GlobalUnlock(hMem);
		  GlobalFree(hBitmapinfoMem);
		  GlobalFree(hMem);
		}
	      }
	    }
	  }
	}
      }
    }
  }

  return(Groesse+Size+Size1);
}

BOOL DelAllIcons(lphXORBmpMem,lphANDBmpMem,lphPalMem,lphResDirMem,lpQuantity,hWnd)
HANDLE FAR *lphXORBmpMem;
HANDLE FAR *lphANDBmpMem;
HANDLE FAR *lphPalMem;
HANDLE FAR *lphResDirMem;
WORD FAR *lpQuantity;
HWND hWnd;
{
  HBITMAP FAR *lphXORBitmap;
  HBITMAP FAR *lphANDBitmap;
  HPALETTE FAR *lphPal;
  ICONRESOURCE FAR *lpResDir;
  int i;

  lphXORBitmap = (HBITMAP FAR*)GlobalLock((HANDLE)*lphXORBmpMem);
  lphANDBitmap = (HBITMAP FAR*)GlobalLock((HANDLE)*lphANDBmpMem);
  lphPal = (HPALETTE FAR*)GlobalLock((HANDLE)*lphPalMem);

  for(i=0;i<*lpQuantity;i++)
  {
    DeleteObject(lphXORBitmap[i]);
    DeleteObject(lphANDBitmap[i]);
    DeleteObject(lphPal[i]);
  }

  GlobalUnlock((HANDLE)*lphXORBmpMem);
  GlobalUnlock((HANDLE)*lphANDBmpMem);
  GlobalUnlock((HANDLE)*lphPalMem);

  *lphXORBmpMem = GlobalReAlloc(*lphXORBmpMem,1,GMEM_MOVEABLE);
  *lphANDBmpMem = GlobalReAlloc(*lphANDBmpMem,1,GMEM_MOVEABLE);
  *lphPalMem = GlobalReAlloc(*lphPalMem,1,GMEM_MOVEABLE);
  *lphResDirMem = GlobalReAlloc(*lphResDirMem,1,GMEM_MOVEABLE);
  *lpQuantity=0;
  return TRUE;

}

BOOL RetrieveIconFile(lphXORBmpMem,lphANDBmpMem,lphPalMem,lphResDirMem,hFile,hWnd,lpQuantity)
HANDLE FAR *lphXORBmpMem;
HANDLE FAR *lphANDBmpMem;
HANDLE FAR *lphPalMem;
HANDLE FAR *lphResDirMem;
HANDLE hFile;
HWND hWnd;
WORD FAR *lpQuantity;
{

  HBITMAP FAR *lphXORBitmap;
  HBITMAP FAR *lphANDBitmap;
  HPALETTE FAR *lphPal;
  ICONRESOURCE FAR *lpResDir;
  WORD i;
  DWORD count;
  ICONFILEHEADER IconFileHeader;


  _llseek(hFile,0,0);
  count = _lread(hFile,(LPSTR)&IconFileHeader,sizeof(ICONFILEHEADER));

  if(IconFileHeader.icoResourceCount==0)
  {
    MessageBox(hWnd, "Die gewhlte Datei enthlt keine Icons, Ladevorgang wird abgebrochen !" ,NULL,MB_OK|MB_ICONHAND);
    return(FALSE);
  }

  if((IconFileHeader.icoReserved==0)&&(IconFileHeader.icoResourceType==1))
  {
    lphXORBitmap = (HBITMAP FAR*)GlobalLock((HANDLE)*lphXORBmpMem);
    lphANDBitmap = (HBITMAP FAR*)GlobalLock((HANDLE)*lphANDBmpMem);
    lphPal = (HPALETTE FAR*)GlobalLock((HANDLE)*lphPalMem);

    for(i=0;i<*lpQuantity;i++)
    {
      DeleteObject(lphXORBitmap[i]);
      DeleteObject(lphANDBitmap[i]);
      DeleteObject(lphPal[i]);
    }

    GlobalUnlock((HANDLE)*lphXORBmpMem);
    GlobalUnlock((HANDLE)*lphANDBmpMem);
    GlobalUnlock((HANDLE)*lphPalMem);

    *lpQuantity=IconFileHeader.icoResourceCount;

    if ((*lphXORBmpMem = (HANDLE)GlobalReAlloc((HANDLE)*lphXORBmpMem,sizeof(HBITMAP)*(*lpQuantity),GMEM_MOVEABLE)) != NULL)
    {
      if((*lphANDBmpMem = (HANDLE)GlobalReAlloc((HANDLE)*lphANDBmpMem,sizeof(HBITMAP)*(*lpQuantity),GMEM_MOVEABLE)) != NULL)
      {
	if((*lphPalMem = (HANDLE)GlobalReAlloc((HANDLE)*lphPalMem,sizeof(HPALETTE)*(*lpQuantity),GMEM_MOVEABLE)) != NULL)
	{
	  if((*lphResDirMem = (HANDLE)GlobalReAlloc((HANDLE)*lphResDirMem,sizeof(ICONRESOURCE)*(*lpQuantity),GMEM_MOVEABLE)) != NULL)
	  {
	    lphXORBitmap = (HBITMAP FAR*)GlobalLock((HANDLE)*lphXORBmpMem);
	    lphANDBitmap = (HBITMAP FAR*)GlobalLock((HANDLE)*lphANDBmpMem);
	    lphPal = (HPALETTE FAR*)GlobalLock((HANDLE)*lphPalMem);
	    lpResDir = (ICONRESOURCE FAR*)GlobalLock((HANDLE)*lphResDirMem);

	    for (i=0;i<*lpQuantity;i++)
	    {
	      _llseek(hFile,count,0);
	      count += _lread(hFile,(LPSTR)&(lpResDir[i]),sizeof(ICONRESOURCE));

	      if((lpResDir[i].ColorCount==2)|(lpResDir[i].ColorCount==8)|(lpResDir[i].ColorCount==16)|(lpResDir[i].Reserved1==1))
	      {
		if(RetrieveIcon(&(lphXORBitmap[i]),&(lphANDBitmap[i]),&(lphPal[i]),lpResDir[i].icoDIBOffset, hFile,hWnd)==FALSE)
		{
		  *lpQuantity=0;
		  GlobalUnlock((HANDLE)*lphXORBmpMem);
		  GlobalUnlock((HANDLE)*lphANDBmpMem);
		  GlobalUnlock((HANDLE)*lphPalMem);
		  GlobalUnlock((HANDLE)*lphResDirMem);
		  return FALSE;
		}
		if(lpResDir[i].ColorCount==8) lpResDir[i].ColorCount=16;
	      }
	      else
	      {
		MessageBox(hWnd, "Icon mit ungltiger Farbenanzahl in Datei enthalten !\nLadevorgang wird abgebrochen !" ,NULL,MB_OK|MB_ICONHAND);
		*lpQuantity=0;
		GlobalUnlock((HANDLE)*lphXORBmpMem);
		GlobalUnlock((HANDLE)*lphANDBmpMem);
		GlobalUnlock((HANDLE)*lphPalMem);
		GlobalUnlock((HANDLE)*lphResDirMem);
		return FALSE;
	      }
	    }
	    GlobalUnlock((HANDLE)*lphXORBmpMem);
	    GlobalUnlock((HANDLE)*lphANDBmpMem);
	    GlobalUnlock((HANDLE)*lphPalMem);
	    GlobalUnlock((HANDLE)*lphResDirMem);
	  }
	  else
	  {
	    MessageBox(hWnd, "Nicht gengend freier Speicher, um Datei zu laden ! Ladevorgang wird abgebrochen !" ,NULL,MB_OK|MB_ICONHAND);
	    *lpQuantity=0;
	    return FALSE;
	  }
	}
	else
	{
	  MessageBox(hWnd, "Nicht gengend freier Speicher, um Datei zu laden ! Ladevorgang wird abgebrochen !" ,NULL,MB_OK|MB_ICONHAND);
	  *lpQuantity=0;
	  return FALSE;
	}
      }
      else
      {
	MessageBox(hWnd, "Nicht gengend freier Speicher, um Datei zu laden ! Ladevorgang wird abgebrochen !" ,NULL,MB_OK|MB_ICONHAND);
	*lpQuantity=0;
	return FALSE;
      }
    }
    else
    {
      MessageBox(hWnd, "Nicht gengend freier Speicher, um Datei zu laden ! Ladevorgang wird abgebrochen !" ,NULL,MB_OK|MB_ICONHAND);
      *lpQuantity=0;
      return FALSE;
    }
    return(TRUE);
  }
  else
  {
    MessageBox(hWnd, "Die gewhlte Datei ist keine gltige Icon-Datei, Ladevorgang wird abgebrochen !" ,NULL,MB_OK|MB_ICONHAND);
    return(FALSE);
  }
}

BOOL SaveIconFile(lphXORBmpMem,lphANDBmpMem,lphPalMem,lphResDirMem,hFile, hWnd, Quantity)
HANDLE FAR *lphXORBmpMem;
HANDLE FAR *lphANDBmpMem;
HANDLE FAR *lphPalMem;
HANDLE FAR *lphResDirMem;
HANDLE hFile;
HWND hWnd;
WORD Quantity;
{

  HBITMAP FAR *lphXORBitmap;
  HBITMAP FAR *lphANDBitmap;
  HPALETTE FAR *lphPal;
  ICONRESOURCE FAR *lpResDir;
  ICONFILEHEADER IconFileHeader;
  DWORD count;
  DWORD count1;
  DWORD Groesse;

  if (hFile)
  {
    lphXORBitmap = (HBITMAP FAR*)GlobalLock((HANDLE)*lphXORBmpMem);
    lphANDBitmap = (HBITMAP FAR*)GlobalLock((HANDLE)*lphANDBmpMem);
    lphPal = (HPALETTE FAR*)GlobalLock((HANDLE)*lphPalMem);
    lpResDir = (ICONRESOURCE FAR*)GlobalLock((HANDLE)*lphResDirMem);
    IconFileHeader.icoReserved=0;
    IconFileHeader.icoResourceType=1;
    IconFileHeader.icoResourceCount=Quantity;

    _llseek(hFile,0,0);

    if((count=_lwrite(hFile,(LPSTR)&IconFileHeader,sizeof(ICONFILEHEADER)))!=sizeof(ICONFILEHEADER))
    {
      MessageBox(hWnd,"Nicht gengend freier Speicher auf Laufwerk!",NULL,MB_OK|MB_ICONHAND);
      GlobalUnlock((HANDLE)*lphXORBmpMem);
      GlobalUnlock((HANDLE)*lphANDBmpMem);
      GlobalUnlock((HANDLE)*lphPalMem);
      GlobalUnlock((HANDLE)*lphResDirMem);
      return FALSE;
    }

    for (i=0;i<Quantity;i++)
    {
      _llseek(hFile,count,0);

      if((count1=_lwrite(hFile,(LPSTR)&(lpResDir[i]),sizeof(ICONRESOURCE)))!=sizeof(ICONRESOURCE))
      {
	MessageBox(hWnd,"Nicht gengend freier Speicher auf Laufwerk!",NULL,MB_OK|MB_ICONHAND);
	GlobalUnlock((HANDLE)*lphXORBmpMem);
	GlobalUnlock((HANDLE)*lphANDBmpMem);
	GlobalUnlock((HANDLE)*lphPalMem);
	GlobalUnlock((HANDLE)*lphResDirMem);
	return FALSE;
      }

      count+=count1;
    }

    for (i=0;i<Quantity;i++)
    {
      _llseek(hFile,18+(16*i),0);

      if((_lwrite(hFile,(LPSTR)&count,sizeof(DWORD)))!=sizeof(DWORD))
      {
	MessageBox(hWnd,"Nicht gengend freier Speicher auf Laufwerk!",NULL,MB_OK|MB_ICONHAND);
	GlobalUnlock((HANDLE)*lphXORBmpMem);
	GlobalUnlock((HANDLE)*lphANDBmpMem);
	GlobalUnlock((HANDLE)*lphPalMem);
	GlobalUnlock((HANDLE)*lphResDirMem);
	return FALSE;
      }

      if((Groesse = SaveIcon(lphXORBitmap[i],lphANDBitmap[i],lphPal[i],count,hFile,hWnd,(WORD)ColBit(lpResDir[i].ColorCount+256*lpResDir[i].Reserved1)))==FALSE)
      {
	MessageBox(hWnd,"Nicht gengend freier Speicher auf Laufwerk!",NULL,MB_OK|MB_ICONHAND);
	GlobalUnlock((HANDLE)*lphXORBmpMem);
	GlobalUnlock((HANDLE)*lphANDBmpMem);
	GlobalUnlock((HANDLE)*lphPalMem);
	GlobalUnlock((HANDLE)*lphResDirMem);
	return FALSE;
      }

      _llseek(hFile,14+(16*i),0);

      if((_lwrite(hFile,(LPSTR)&Groesse,sizeof(DWORD)))!=sizeof(DWORD))
      {
	MessageBox(hWnd,"Nicht gengend freier Speicher auf Laufwerk!",NULL,MB_OK|MB_ICONHAND);
	GlobalUnlock((HANDLE)*lphXORBmpMem);
	GlobalUnlock((HANDLE)*lphANDBmpMem);
	GlobalUnlock((HANDLE)*lphPalMem);
	GlobalUnlock((HANDLE)*lphResDirMem);
	return FALSE;
      }

      count+=Groesse;
    }

    GlobalUnlock((HANDLE)*lphXORBmpMem);
    GlobalUnlock((HANDLE)*lphANDBmpMem);
    GlobalUnlock((HANDLE)*lphPalMem);
    GlobalUnlock((HANDLE)*lphResDirMem);
    return TRUE;
  }

  return FALSE;
}


BOOL DelIcon(lphXORBmpMem,lphANDBmpMem,lphPalMem,lphResDirMem,lpQuantity,hWnd,CurrIcon)
HANDLE FAR *lphXORBmpMem;
HANDLE FAR *lphANDBmpMem;
HANDLE FAR *lphPalMem;
HANDLE FAR *lphResDirMem;
WORD FAR *lpQuantity;
HWND hWnd;
int CurrIcon;
{
  int i;

  FARPROC lpDlgSelIcon;
  HBITMAP FAR *lphXORBitmap;
  HBITMAP FAR *lphANDBitmap;
  HPALETTE FAR *lphPal;
  ICONRESOURCE FAR *lpResDir;

  lphXORBitmap = (HBITMAP FAR*)GlobalLock((HANDLE)*lphXORBmpMem);
  lphANDBitmap = (HBITMAP FAR*)GlobalLock((HANDLE)*lphANDBmpMem);
  lphPal = (HPALETTE FAR*)GlobalLock((HANDLE)*lphPalMem);
  lpResDir = (ICONRESOURCE FAR*)GlobalLock((HANDLE)*lphResDirMem);

  DeleteObject(lphXORBitmap[CurrIcon]);
  DeleteObject(lphANDBitmap[CurrIcon]);
  DeleteObject(lphPal[CurrIcon]);

  for (i=CurrIcon;i<(*lpQuantity)-1;i++)
  {
    lphXORBitmap[i]=lphXORBitmap[i+1];
    lphANDBitmap[i]=lphANDBitmap[i+1];
    lphPal[i]=lphPal[i+1];
    lpResDir[i]=lpResDir[i+1];
  }

  GlobalUnlock((HANDLE)*lphXORBmpMem);
  GlobalUnlock((HANDLE)*lphANDBmpMem);
  GlobalUnlock((HANDLE)*lphPalMem);
  GlobalUnlock((HANDLE)*lphResDirMem);

  (*lpQuantity)--;

  if(*lpQuantity<1)
  {
    *lphXORBmpMem = (HANDLE)GlobalReAlloc((HANDLE)*lphXORBmpMem,1,GMEM_MOVEABLE);
    *lphANDBmpMem = (HANDLE)GlobalReAlloc((HANDLE)*lphANDBmpMem,1,GMEM_MOVEABLE);
    *lphPalMem = (HANDLE)GlobalReAlloc((HANDLE)*lphPalMem,1,GMEM_MOVEABLE);
    *lphResDirMem = (HANDLE)GlobalReAlloc((HANDLE)*lphResDirMem,1,GMEM_MOVEABLE);
  }
  else
  {
    *lphXORBmpMem = (HANDLE)GlobalReAlloc((HANDLE)*lphXORBmpMem,sizeof(HBITMAP)*(*lpQuantity),GMEM_MOVEABLE);
    *lphANDBmpMem = (HANDLE)GlobalReAlloc((HANDLE)*lphANDBmpMem,sizeof(HBITMAP)*(*lpQuantity),GMEM_MOVEABLE);
    *lphPalMem = (HANDLE)GlobalReAlloc((HANDLE)*lphPalMem,sizeof(HPALETTE)*(*lpQuantity),GMEM_MOVEABLE);
    *lphResDirMem = (HANDLE)GlobalReAlloc((HANDLE)*lphResDirMem,sizeof(ICONRESOURCE)*(*lpQuantity),GMEM_MOVEABLE);
  }
  return TRUE;
}

BYTE ColBit(Farben)
int Farben;
{
  switch(Farben)
  {
    case 2:
      return 1;
      break;
    case 8:
    case 16:
      return 4;
      break;
    case 256:
      return 8;
  }
  return 0;
}

int BitCol(Bits)
BYTE Bits;
{
  switch(Bits)
  {
    case 1:
      return 2;
    case 4:
      return 16;
    case 8:
      return 256;
  }
  return 0;
}

BOOL RetrieveIconFile2(lphXORBmpMem,lphANDBmpMem,lphPalMem,lphResDirMem,hFile,hWnd,lpQuantity, lpVer20)
HANDLE FAR *lphXORBmpMem;
HANDLE FAR *lphANDBmpMem;
HANDLE FAR *lphPalMem;
HANDLE FAR *lphResDirMem;
HANDLE hFile;
HWND hWnd;
WORD FAR *lpQuantity;
BOOL FAR *lpVer20;
{

  HBITMAP FAR *lphXORBitmap;
  HBITMAP FAR *lphANDBitmap;
  HPALETTE FAR *lphPal;
  ICONRESOURCE FAR *lpResDir;
  WORD i;
  char ID[2];
  DWORD count;
  DWORD Info1Start;
  DWORD Info2Start;
  BITMAPFILEHEADER2 BitmapFileHeader2AND;
  BITMAPFILEHEADER2 BitmapFileHeader2XOR;
  BITMAPARRAYFILEHEADER2 BitmapArrayFileHeader2;

  _llseek(hFile, 0,0);
  _lread(hFile,ID,2);

  if((ID[0]=='B')&&(ID[1]=='A'))
  {
    lphXORBitmap = (HBITMAP FAR*)GlobalLock((HANDLE)*lphXORBmpMem);
    lphANDBitmap = (HBITMAP FAR*)GlobalLock((HANDLE)*lphANDBmpMem);
    lphPal = (HPALETTE FAR*)GlobalLock((HANDLE)*lphPalMem);

    for(i=0;i<*lpQuantity;i++)
    {
      DeleteObject(lphXORBitmap[i]);
      DeleteObject(lphANDBitmap[i]);
      DeleteObject(lphPal[i]);
    }

    GlobalUnlock((HANDLE)*lphXORBmpMem);
    GlobalUnlock((HANDLE)*lphANDBmpMem);
    GlobalUnlock((HANDLE)*lphPalMem);

    count=0;
    *lpQuantity=0;
    i=0;

    do
    {
      (*lpQuantity)++;
      if ((*lphXORBmpMem = (HANDLE)GlobalReAlloc((HANDLE)*lphXORBmpMem,sizeof(HBITMAP)*(*lpQuantity),GMEM_MOVEABLE)) != NULL)
      {
	if((*lphANDBmpMem = (HANDLE)GlobalReAlloc((HANDLE)*lphANDBmpMem,sizeof(HBITMAP)*(*lpQuantity),GMEM_MOVEABLE)) != NULL)
	{
	  if((*lphPalMem = (HANDLE)GlobalReAlloc((HANDLE)*lphPalMem,sizeof(HPALETTE)*(*lpQuantity),GMEM_MOVEABLE)) != NULL)
	  {
	    if((*lphResDirMem = (HANDLE)GlobalReAlloc((HANDLE)*lphResDirMem,sizeof(ICONRESOURCE)*(*lpQuantity),GMEM_MOVEABLE)) != NULL)
	    {
	      lphXORBitmap = (HBITMAP FAR*)GlobalLock((HANDLE)*lphXORBmpMem);
	      lphANDBitmap = (HBITMAP FAR*)GlobalLock((HANDLE)*lphANDBmpMem);
	      lphPal = (HPALETTE FAR*)GlobalLock((HANDLE)*lphPalMem);
	      lpResDir = (ICONRESOURCE FAR*)GlobalLock((HANDLE)*lphResDirMem);

	      _llseek(hFile,count,0);
	      count += _lread(hFile,(LPSTR)&(BitmapArrayFileHeader2),sizeof(BITMAPARRAYFILEHEADER2));
	      count += _lread(hFile,(LPSTR)&(BitmapFileHeader2AND),sizeof(BITMAPFILEHEADER));
	      Info1Start=count;

	      switch(BitmapArrayFileHeader2.cbSize)
	      {
		case 0x5C:
		  *lpVer20=TRUE;
		  break;
		case 0x28:
		  *lpVer20=FALSE;
		  break;
	      }

	      switch(BitmapFileHeader2AND.usType)
	      {
		case 0x4943:

		  if(*lpVer20)
		    count += sizeof(BITMAPCOREHEADER2)+2*sizeof(RGBQUAD);
		  else
		    count += sizeof(BITMAPCOREHEADER)+2*sizeof(RGBTRIPLE);

		  _llseek(hFile,count,0);
		  count += _lread(hFile,(LPSTR)&(BitmapFileHeader2XOR),sizeof(BITMAPFILEHEADER));
		  Info2Start=count;
		  break;
		case 0x4349:
		  Info2Start=Info1Start;
		  Info1Start=0;
		  BitmapFileHeader2XOR.offBits=BitmapFileHeader2AND.offBits;
		  BitmapFileHeader2AND.offBits=0;
		  break;
	      }

	      count=BitmapArrayFileHeader2.offNext;

	      if(RetrieveIcon2(&(lphXORBitmap[i]),&(lphANDBitmap[i]),&(lphPal[i]),&(lpResDir[i]),BitmapFileHeader2AND.offBits,BitmapFileHeader2XOR.offBits, Info1Start, Info2Start, hFile, hWnd, *lpVer20)==FALSE)
	      {
		*lpQuantity=0;
		GlobalUnlock((HANDLE)*lphXORBmpMem);
		GlobalUnlock((HANDLE)*lphANDBmpMem);
		GlobalUnlock((HANDLE)*lphPalMem);
		GlobalUnlock((HANDLE)*lphResDirMem);
		return FALSE;
	      }

	      GlobalUnlock((HANDLE)*lphXORBmpMem);
	      GlobalUnlock((HANDLE)*lphANDBmpMem);
	      GlobalUnlock((HANDLE)*lphPalMem);
	      GlobalUnlock((HANDLE)*lphResDirMem);
	    }
	    else
	    {
	      MessageBox(hWnd, "Nicht gengend freier Speicher, um Datei zu laden ! Ladevorgang wird abgebrochen !" ,NULL,MB_OK|MB_ICONHAND);
	      *lpQuantity=0;
	      return FALSE;
	    }
	  }
	  else
	  {
	    MessageBox(hWnd, "Nicht gengend freier Speicher, um Datei zu laden ! Ladevorgang wird abgebrochen !" ,NULL,MB_OK|MB_ICONHAND);
	    *lpQuantity=0;
	    return FALSE;
	  }
	}
	else
	{
	  MessageBox(hWnd, "Nicht gengend freier Speicher, um Datei zu laden ! Ladevorgang wird abgebrochen !" ,NULL,MB_OK|MB_ICONHAND);
	  *lpQuantity=0;
	  return FALSE;
	}
      }
      else
      {
	MessageBox(hWnd, "Nicht gengend freier Speicher, um Datei zu laden ! Ladevorgang wird abgebrochen !" ,NULL,MB_OK|MB_ICONHAND);
	*lpQuantity=0;
	return FALSE;
      }
      i++;
    }
    while(count!=0);
    return(TRUE);
  }
  else
  {
    MessageBox(hWnd, "Die gewhlte Datei ist keine gltige Icon-Datei, Ladevorgang wird abgebrochen !" ,NULL,MB_OK|MB_ICONHAND);
    return(FALSE);
  }
}

RetrieveIcon2(lphXORBitmap,lphANDBitmap,lphPal,lpResDir,BegPosData1,BegPosData2,BegPosInfo1,BegPosInfo2,hFile,hWnd,Ver20)
HBITMAP FAR *lphXORBitmap;
HBITMAP FAR *lphANDBitmap;
HPALETTE FAR *lphPal;
ICONRESOURCE FAR *lpResDir;
DWORD BegPosData1;
DWORD BegPosData2;
DWORD BegPosInfo1;
DWORD BegPosInfo2;
int hFile;
HWND hWnd;
BOOL Ver20;
{
  HDC hDC;
  HDC hDC1;
  HDC hDC2;
  HDC hDC3;
  DWORD Size;
  DWORD Groesse;
  DWORD Size1;
  WORD PalEntrys;
  LPBITMAPINFO lpBitmapInfo;
  BITMAPCOREINFO BitmapCoreInfo;
  LPBITMAPCOREINFO lpBitmapCoreInfo;
  BITMAPCOREINFO2 BitmapCoreInfo2;
  LPBITMAPCOREINFO2 lpBitmapCoreInfo2;
  LPSTR lpMem;
  LPSTR lpResult;
  HANDLE hBitmapCoreInfoMem;
  HANDLE hBitmapInfoMem;
  HANDLE hMem;
  int count;
  int i;
  int j;
  RGBTRIPLE FAR *pRgbt;
  RGBQUAD FAR *pRgb;
  LOGPALETTE *pPal;
  WORD FAR *pw;
  HBITMAP hXORBitmap;
  HBITMAP hOldBitmap1;
  HBITMAP hOldBitmap2;
  HBITMAP hOldBitmap3;
  HPALETTE hOldPal;
  DWORD dColor;

  _llseek(hFile,BegPosInfo2,0);
  if(Ver20)
  {
    count = _lread(hFile,(LPSTR)&BitmapCoreInfo2.bmciHeader,sizeof(BITMAPCOREHEADER2));
    if(BegPosData1==0) BitmapCoreInfo2.bmciHeader.cy/=2;

    PalEntrys=(WORD)BitCol((BYTE)BitmapCoreInfo2.bmciHeader.cBitCount);

    lpResDir->Width=BitmapCoreInfo2.bmciHeader.cx;
    lpResDir->Height=BitmapCoreInfo2.bmciHeader.cy;
  }
  else
  {
    count = _lread(hFile,(LPSTR)&BitmapCoreInfo.bmciHeader,sizeof(BITMAPCOREHEADER));
    if(BegPosData1==0) BitmapCoreInfo.bmciHeader.bcHeight/=2;

    PalEntrys=(WORD)BitCol((BYTE)BitmapCoreInfo.bmciHeader.bcBitCount);

    lpResDir->Width=BitmapCoreInfo.bmciHeader.bcWidth;

    lpResDir->Height=BitmapCoreInfo.bmciHeader.bcHeight;

  }

  lpResDir->ColorCount=LOBYTE(PalEntrys);
  lpResDir->Reserved1=HIBYTE(PalEntrys);
  lpResDir->Reserved2=0;
  lpResDir->Reserved3=0;

  if ((PalEntrys!=2)&&(PalEntrys!=16)&&(PalEntrys!=256))
  {
    MessageBox(hWnd, "Die gewhlte Datei ist keine gltige Icon-Datei, Ladevorgang wird abgebrochen !" ,NULL,MB_OK|MB_ICONHAND);
    return(FALSE);
  }

  if(Ver20)
  {
    Groesse = sizeof(BITMAPCOREHEADER2)+PalEntrys*sizeof(RGBQUAD);
    Size=CalcSize((WORD)BitmapCoreInfo2.bmciHeader.cx, (WORD)BitmapCoreInfo2.bmciHeader.cy, BitmapCoreInfo2.bmciHeader.cBitCount);
  }
  else
  {
    Groesse = sizeof(BITMAPCOREHEADER)+PalEntrys*sizeof(RGBTRIPLE);
    Size=CalcSize(BitmapCoreInfo.bmciHeader.bcWidth, BitmapCoreInfo.bmciHeader.bcHeight, BitmapCoreInfo.bmciHeader.bcBitCount);
  }

  if ((hBitmapCoreInfoMem = GlobalAlloc(GMEM_MOVEABLE,Groesse)) != NULL)
  {
    if ((hMem = GlobalAlloc(GMEM_MOVEABLE,Size)) != NULL)
    {
      if((lpResult=GlobalLock(hBitmapCoreInfoMem))!= NULL)
      {
	if(Ver20)
	  lpBitmapCoreInfo2=(LPBITMAPCOREINFO2)lpResult;
	else
	  lpBitmapCoreInfo=(LPBITMAPCOREINFO)lpResult;

	if((lpMem = GlobalLock(hMem)) != (LPSTR) NULL)
	{
	  _llseek(hFile,BegPosInfo2,0);

	  if(Ver20)
	  {
	    count = _lread(hFile,(LPSTR)lpBitmapCoreInfo2,(WORD)Groesse);
	    if(BegPosData1==0) lpBitmapCoreInfo2->bmciHeader.cy/=2;
	  }
	  else
	  {
	    count = _lread(hFile,(LPSTR)lpBitmapCoreInfo,(WORD)Groesse);
	    if(BegPosData1==0) lpBitmapCoreInfo->bmciHeader.bcHeight/=2;
	  }

	  _llseek(hFile,BegPosData2,0);
	  count= _lread(hFile,(LPSTR)lpMem, (WORD)Size);

	  if(Ver20)
	    pRgb = (RGBQUAD FAR *)((LPSTR)lpBitmapCoreInfo2->bmciColors);
	  else
	    pRgbt = (RGBTRIPLE FAR *)((LPSTR)lpBitmapCoreInfo->bmciColors);

	  pPal = (LOGPALETTE*)LocalAlloc(LPTR, sizeof(LOGPALETTE) + PalEntrys * sizeof(PALETTEENTRY));

	  if (!pPal)
	    return FALSE;

	  pPal->palNumEntries = PalEntrys;
	  pPal->palVersion    = 0x300;

	  if(Ver20)
	  {
	    for (i = 0; i < PalEntrys; i++)
	    {
	      pPal->palPalEntry[i].peRed = pRgb[i].rgbRed;
	      pPal->palPalEntry[i].peGreen = pRgb[i].rgbGreen;
	      pPal->palPalEntry[i].peBlue  = pRgb[i].rgbBlue;
	      pPal->palPalEntry[i].peFlags = (BYTE)0;
	    }
	  }
	  else
	  {
	    for (i = 0; i < PalEntrys; i++)
	    {
	      pPal->palPalEntry[i].peRed = pRgbt[i].rgbtRed;
	      pPal->palPalEntry[i].peGreen = pRgbt[i].rgbtGreen;
	      pPal->palPalEntry[i].peBlue  = pRgbt[i].rgbtBlue;
	      pPal->palPalEntry[i].peFlags = (BYTE)0;
	    }
	  }

	  *lphPal = CreatePalette(pPal);
	  LocalFree((HANDLE)pPal);

	  hDC = GetDC(NULL);

	  hOldPal=SelectPalette(hDC,*lphPal,TRUE);
	  RealizePalette(hDC);

	  if(Ver20)
	  {
	    if ((hBitmapInfoMem = GlobalAlloc(GMEM_MOVEABLE,sizeof(BITMAPINFOHEADER)+PalEntrys*sizeof(WORD))) != NULL)
	    {
	      if((lpBitmapInfo=(LPBITMAPINFO)GlobalLock(hBitmapInfoMem))!= NULL)
	      {
		lpBitmapInfo->bmiHeader.biSize=(long)sizeof(BITMAPINFOHEADER);
		lpBitmapInfo->bmiHeader.biWidth=lpBitmapCoreInfo2->bmciHeader.cx;
		lpBitmapInfo->bmiHeader.biHeight=lpBitmapCoreInfo2->bmciHeader.cy;
		lpBitmapInfo->bmiHeader.biPlanes=lpBitmapCoreInfo2->bmciHeader.cPlanes;
		lpBitmapInfo->bmiHeader.biBitCount=lpBitmapCoreInfo2->bmciHeader.cBitCount;
		lpBitmapInfo->bmiHeader.biCompression=lpBitmapCoreInfo2->bmciHeader.ulCompression;
		lpBitmapInfo->bmiHeader.biSizeImage=lpBitmapCoreInfo2->bmciHeader.cbImage;
		lpBitmapInfo->bmiHeader.biXPelsPerMeter=lpBitmapCoreInfo2->bmciHeader.cxResolution;
		lpBitmapInfo->bmiHeader.biYPelsPerMeter=lpBitmapCoreInfo2->bmciHeader.cyResolution;
		lpBitmapInfo->bmiHeader.biClrUsed=lpBitmapCoreInfo2->bmciHeader.cclrUsed;
		lpBitmapInfo->bmiHeader.biClrImportant=lpBitmapCoreInfo2->bmciHeader.cclrImportant;

		pw = (WORD FAR *)((LPSTR)lpBitmapInfo->bmiColors);

		for (i=0; i<(int)PalEntrys; i++)
		  *pw++ = (WORD)i;

		*lphXORBitmap=CreateDIBitmap(hDC,(LPBITMAPINFOHEADER)&(lpBitmapInfo->bmiHeader),CBM_INIT,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapInfo,DIB_PAL_COLORS);

		GlobalUnlock(hBitmapInfoMem);
		GlobalFree(hBitmapInfoMem);
	      }
	    }
	  }
	  else
	  {
	    if ((hBitmapInfoMem = GlobalAlloc(GMEM_MOVEABLE,sizeof(BITMAPINFOHEADER)+PalEntrys*sizeof(WORD))) != NULL)
	    {
	      if((lpBitmapInfo=(LPBITMAPINFO)GlobalLock(hBitmapInfoMem))!= NULL)
	      {
		lpBitmapInfo->bmiHeader.biSize=(long)sizeof(BITMAPINFOHEADER);
		lpBitmapInfo->bmiHeader.biWidth=lpBitmapCoreInfo->bmciHeader.bcWidth;
		lpBitmapInfo->bmiHeader.biHeight=lpBitmapCoreInfo->bmciHeader.bcHeight;
		lpBitmapInfo->bmiHeader.biPlanes=lpBitmapCoreInfo->bmciHeader.bcPlanes;
		lpBitmapInfo->bmiHeader.biBitCount=lpBitmapCoreInfo->bmciHeader.bcBitCount;
		lpBitmapInfo->bmiHeader.biCompression=0L;
		lpBitmapInfo->bmiHeader.biSizeImage=0L;
		lpBitmapInfo->bmiHeader.biXPelsPerMeter=0L;
		lpBitmapInfo->bmiHeader.biYPelsPerMeter=0L;
		lpBitmapInfo->bmiHeader.biClrUsed=PalEntrys;
		lpBitmapInfo->bmiHeader.biClrImportant=0L;

		pw = (WORD FAR *)((LPSTR)lpBitmapInfo->bmiColors);

		for (i=0; i<(int)PalEntrys; i++)
		  *pw++ = (WORD)i;

		*lphXORBitmap=CreateDIBitmap(hDC,(LPBITMAPINFOHEADER)&(lpBitmapInfo->bmiHeader),CBM_INIT,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapInfo,DIB_PAL_COLORS);

		GlobalUnlock(hBitmapInfoMem);
		GlobalFree(hBitmapInfoMem);
	      }
	    }
	  }

	  SelectPalette(hDC, hOldPal, FALSE);

	  ReleaseDC(NULL,hDC);
	  GlobalUnlock(hMem);
	  GlobalFree(hMem);
	  GlobalUnlock(hBitmapCoreInfoMem);
	  GlobalFree(hBitmapCoreInfoMem);
	  if (*lphXORBitmap)
	  {
	    if(Ver20)
	    {
	      Size1=CalcSize((WORD)BitmapCoreInfo2.bmciHeader.cx, (WORD)BitmapCoreInfo2.bmciHeader.cy, 1);
	      Groesse = sizeof(BITMAPCOREHEADER2)+2*sizeof(RGBQUAD);
	    }
	    else
	    {
	      Size1=CalcSize(BitmapCoreInfo.bmciHeader.bcWidth, BitmapCoreInfo.bmciHeader.bcHeight, 1);
	      Groesse = sizeof(BITMAPCOREHEADER)+2*sizeof(RGBTRIPLE);
	    }

	    if ((hMem = GlobalAlloc(GMEM_MOVEABLE|GMEM_ZEROINIT,Size1)) != NULL)
	    {
	      if ((hBitmapCoreInfoMem = GlobalAlloc(GMEM_MOVEABLE,Groesse)) != NULL)
	      {
		if((lpMem = GlobalLock(hMem)) != (LPSTR) NULL)
		{
		  if((lpResult=GlobalLock(hBitmapCoreInfoMem))!= NULL)
		  {
		    if(Ver20)
		      lpBitmapCoreInfo2 = (LPBITMAPCOREINFO2)lpResult;
		    else
		      lpBitmapCoreInfo = (LPBITMAPCOREINFO)lpResult;

		    if(BegPosInfo1!=0)
		    {
		      _llseek(hFile,BegPosInfo1,0);

		      if(Ver20)
		      {
			count = _lread(hFile,(LPSTR)lpBitmapCoreInfo2,(WORD)Groesse);
			lpBitmapCoreInfo2->bmciHeader.cy/=2;
		      }
		      else
		      {
			count = _lread(hFile,(LPSTR)lpBitmapCoreInfo,(WORD)Groesse);
			lpBitmapCoreInfo->bmciHeader.bcHeight/=2;
		      }

		      hDC=GetDC(NULL);

		      _llseek(hFile,BegPosData1,0);
		      count=_lread(hFile,(LPSTR)lpMem,(WORD)Size1);

		      if(Ver20)
		      {
			if ((hBitmapInfoMem = GlobalAlloc(GMEM_MOVEABLE,sizeof(BITMAPINFOHEADER)+2*sizeof(RGBQUAD))) != NULL)
			{
			  if((lpBitmapInfo=(LPBITMAPINFO)GlobalLock(hBitmapInfoMem))!= NULL)
			  {
			    lpBitmapInfo->bmiHeader.biSize=(long)sizeof(BITMAPINFOHEADER);
			    lpBitmapInfo->bmiHeader.biWidth=lpBitmapCoreInfo2->bmciHeader.cx;
			    lpBitmapInfo->bmiHeader.biHeight=lpBitmapCoreInfo2->bmciHeader.cy;
			    lpBitmapInfo->bmiHeader.biPlanes=lpBitmapCoreInfo2->bmciHeader.cPlanes;
			    lpBitmapInfo->bmiHeader.biBitCount=lpBitmapCoreInfo2->bmciHeader.cBitCount;
			    lpBitmapInfo->bmiHeader.biCompression=lpBitmapCoreInfo2->bmciHeader.ulCompression;
			    lpBitmapInfo->bmiHeader.biSizeImage=lpBitmapCoreInfo2->bmciHeader.cbImage;
			    lpBitmapInfo->bmiHeader.biXPelsPerMeter=lpBitmapCoreInfo2->bmciHeader.cxResolution;
			    lpBitmapInfo->bmiHeader.biYPelsPerMeter=lpBitmapCoreInfo2->bmciHeader.cyResolution;
			    lpBitmapInfo->bmiHeader.biClrUsed=lpBitmapCoreInfo2->bmciHeader.cclrUsed;
			    lpBitmapInfo->bmiHeader.biClrImportant=lpBitmapCoreInfo2->bmciHeader.cclrImportant;

			    for (i = 0; i < 2; i++)
			    {
			      lpBitmapInfo->bmiColors[i].rgbRed= lpBitmapCoreInfo2->bmciColors[i].rgbRed;
			      lpBitmapInfo->bmiColors[i].rgbGreen= lpBitmapCoreInfo2->bmciColors[i].rgbGreen;
			      lpBitmapInfo->bmiColors[i].rgbBlue= lpBitmapCoreInfo2->bmciColors[i].rgbBlue;
			      lpBitmapInfo->bmiColors[i].rgbReserved= lpBitmapCoreInfo2->bmciColors[i].rgbReserved;
			    }

			    hXORBitmap = CreateDIBitmap(hDC,(LPBITMAPINFOHEADER)&(lpBitmapInfo->bmiHeader),CBM_INIT,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapInfo, DIB_RGB_COLORS);
			    count=_lread(hFile,(LPSTR)lpMem,(WORD)Size1);
			    *lphANDBitmap = CreateDIBitmap(hDC,(LPBITMAPINFOHEADER)&(lpBitmapInfo->bmiHeader),CBM_INIT,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapInfo, DIB_RGB_COLORS);

			    GlobalUnlock(hBitmapInfoMem);
			    GlobalFree(hBitmapInfoMem);
			  }
			}
		      }
		      else
		      {
			hXORBitmap = CreateDIBitmap(hDC,(LPBITMAPINFOHEADER)&(lpBitmapCoreInfo->bmciHeader),CBM_INIT,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapCoreInfo, DIB_RGB_COLORS);
			count=_lread(hFile,(LPSTR)lpMem,(WORD)Size1);
			*lphANDBitmap = CreateDIBitmap(hDC,(LPBITMAPINFOHEADER)&(lpBitmapCoreInfo->bmciHeader),CBM_INIT,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapCoreInfo, DIB_RGB_COLORS);
		      }

		      GlobalUnlock(hBitmapCoreInfoMem);
		      GlobalUnlock(hMem);
		      GlobalFree(hBitmapCoreInfoMem);
		      GlobalFree(hMem);

		      hDC1=CreateCompatibleDC(hDC);
		      hDC2=CreateCompatibleDC(hDC);
		      hDC3=CreateCompatibleDC(hDC);

		      ReleaseDC(NULL,hDC);

		      SelectPalette(hDC1,*lphPal,FALSE);
		      RealizePalette(hDC1);
		      SelectPalette(hDC2,*lphPal,FALSE);
		      RealizePalette(hDC2);
		      SelectPalette(hDC3,*lphPal,FALSE);
		      RealizePalette(hDC3);

		      hOldBitmap1=SelectObject(hDC1,*lphXORBitmap);
		      hOldBitmap2=SelectObject(hDC2,*lphANDBitmap);
		      hOldBitmap3=SelectObject(hDC3,hXORBitmap);

		      for(i=0;i<lpResDir->Width;i++)
		      {
			for(j=0;j<lpResDir->Height;j++)
			{
			  if(GetPixel(hDC2,i,j)==RGB(255,255,255))
			    SetPixel(hDC1,i,j,GetPixel(hDC3,i,j));
			}
		      }

		      SelectObject(hDC1,hOldBitmap1);
		      SelectObject(hDC2,hOldBitmap2);
		      SelectObject(hDC3,hOldBitmap3);

		      DeleteDC(hDC1);
		      DeleteDC(hDC2);
		      DeleteDC(hDC3);

		      DeleteObject(hXORBitmap);

		    }
		    else
		    {
		      _llseek(hFile,BegPosData2+Size,0);
		      count= _lread(hFile,(LPSTR)lpMem, (WORD)Size);

		      hDC=GetDC(NULL);

		      if(Ver20)
		      {
			if ((hBitmapInfoMem = GlobalAlloc(GMEM_MOVEABLE,sizeof(BITMAPINFOHEADER)+PalEntrys*sizeof(RGBQUAD))) != NULL)
			{
			  if((lpBitmapInfo=(LPBITMAPINFO)GlobalLock(hBitmapInfoMem))!= NULL)
			  {
			    lpBitmapInfo->bmiHeader.biSize=(long)sizeof(BITMAPINFOHEADER);
			    lpBitmapInfo->bmiHeader.biWidth=BitmapCoreInfo2.bmciHeader.cx;
			    lpBitmapInfo->bmiHeader.biHeight=BitmapCoreInfo2.bmciHeader.cy;
			    lpBitmapInfo->bmiHeader.biPlanes=1;
			    lpBitmapInfo->bmiHeader.biBitCount=1;
			    lpBitmapInfo->bmiHeader.biCompression=0L;
			    lpBitmapInfo->bmiHeader.biSizeImage=0L;
			    lpBitmapInfo->bmiHeader.biXPelsPerMeter=0L;
			    lpBitmapInfo->bmiHeader.biYPelsPerMeter=0L;
			    lpBitmapInfo->bmiHeader.biClrUsed=0L;
			    lpBitmapInfo->bmiHeader.biClrImportant=0L;
			    lpBitmapInfo->bmiColors[0].rgbRed=0;
			    lpBitmapInfo->bmiColors[0].rgbGreen=0;
			    lpBitmapInfo->bmiColors[0].rgbBlue=0;
			    lpBitmapInfo->bmiColors[0].rgbReserved=0;
			    lpBitmapInfo->bmiColors[1].rgbRed=0xff;
			    lpBitmapInfo->bmiColors[1].rgbGreen=0xff;
			    lpBitmapInfo->bmiColors[1].rgbBlue=0xff;
			    lpBitmapInfo->bmiColors[1].rgbReserved=0;

			    *lphANDBitmap = CreateDIBitmap(hDC,(LPBITMAPINFOHEADER)&(lpBitmapInfo->bmiHeader),CBM_INIT,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapInfo, DIB_RGB_COLORS);
			    GlobalUnlock(hBitmapInfoMem);
			    GlobalFree(hBitmapInfoMem);
			  }
			}
		      }
		      else
		      {
			lpBitmapCoreInfo->bmciHeader.bcSize=(long)sizeof(BITMAPCOREHEADER);
			lpBitmapCoreInfo->bmciHeader.bcWidth=BitmapCoreInfo.bmciHeader.bcWidth;
			lpBitmapCoreInfo->bmciHeader.bcHeight=BitmapCoreInfo.bmciHeader.bcHeight;
			lpBitmapCoreInfo->bmciHeader.bcPlanes=1;
			lpBitmapCoreInfo->bmciHeader.bcBitCount=1;
			lpBitmapCoreInfo->bmciColors[0].rgbtRed=0;
			lpBitmapCoreInfo->bmciColors[0].rgbtGreen=0;
			lpBitmapCoreInfo->bmciColors[0].rgbtBlue=0;
			lpBitmapCoreInfo->bmciColors[1].rgbtRed=0xff;
			lpBitmapCoreInfo->bmciColors[1].rgbtGreen=0xff;
			lpBitmapCoreInfo->bmciColors[1].rgbtBlue=0xff;
			*lphANDBitmap = CreateDIBitmap(hDC,(LPBITMAPINFOHEADER)&(lpBitmapCoreInfo->bmciHeader),CBM_INIT,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapCoreInfo, DIB_RGB_COLORS);
		      }

		      ReleaseDC(NULL,hDC);

		      GlobalUnlock(hBitmapCoreInfoMem);
		      GlobalUnlock(hMem);
		      GlobalFree(hBitmapCoreInfoMem);
		      GlobalFree(hMem);

		    }
		  }
		}
	      }
	    }
	  }
	  else
	  {
	    MessageBox(hWnd, "Bitmap konnte nicht erstellt werden !" ,NULL,MB_OK|MB_ICONHAND);
	    return FALSE;
	  }
	}
      }
    }
  }
  return TRUE;
}

BOOL CopyIcon(lphXORBitmap,lphANDBitmap,lphPal,lpResDir,CurrIcon,Quantity,CurrFile,hWnd)
HBITMAP FAR **lphXORBitmap;
HBITMAP FAR **lphANDBitmap;
HPALETTE FAR **lphPal;
ICONRESOURCE FAR **lpResDir;
int CurrIcon;
int Quantity;
int CurrFile;
HWND hWnd;
{

  HDC hDC;
  DWORD Size;
  DWORD Groesse;
  DWORD Size1;
  LPBITMAPINFO lpBitmapinfo;
  LPSTR lpMem;
  HANDLE hBitmapinfoMem;
  HANDLE hMem;
  int count;
  WORD PalEntrys;
  int OtherFile;
  RGBQUAD FAR *pRgb;
  LOGPALETTE *pPal;
  WORD FAR *pw;

  if(CurrFile==0) OtherFile=1;
  if(CurrFile==1) OtherFile=0;

  GetObject(lphPal[CurrFile][CurrIcon],2,(LPSTR)&PalEntrys);
  Groesse = sizeof(BITMAPINFOHEADER)+PalEntrys*sizeof(RGBQUAD);

  Size = CalcSize(lpResDir[CurrFile][CurrIcon].Width, lpResDir[CurrFile][CurrIcon].Height, ColBit(lpResDir[CurrFile][CurrIcon].ColorCount+256*lpResDir[CurrFile][CurrIcon].Reserved1));

  if ((hBitmapinfoMem = GlobalAlloc(GMEM_MOVEABLE,Groesse)) != NULL)
  {
    if ((hMem = GlobalAlloc(GMEM_MOVEABLE,Size)) != NULL)
    {
      if((lpBitmapinfo = (LPBITMAPINFO)GlobalLock(hBitmapinfoMem)) != NULL)
      {
	if((lpMem = GlobalLock(hMem)) != (LPSTR) NULL)
	{

	  lpBitmapinfo->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	  lpBitmapinfo->bmiHeader.biWidth = lpResDir[CurrFile][CurrIcon].Width;
	  lpBitmapinfo->bmiHeader.biHeight = lpResDir[CurrFile][CurrIcon].Height;
	  lpBitmapinfo->bmiHeader.biPlanes = 1;
	  lpBitmapinfo->bmiHeader.biBitCount = ColBit(lpResDir[CurrFile][CurrIcon].ColorCount+256*lpResDir[CurrFile][CurrIcon].Reserved1);
	  lpBitmapinfo->bmiHeader.biCompression = 0;
	  lpBitmapinfo->bmiHeader.biSizeImage = 0;
	  lpBitmapinfo->bmiHeader.biXPelsPerMeter = 0;
	  lpBitmapinfo->bmiHeader.biYPelsPerMeter = 0;
	  lpBitmapinfo->bmiHeader.biClrUsed = PalEntrys;
	  lpBitmapinfo->bmiHeader.biClrImportant = 0;

	  hDC=GetDC(NULL);

	  SelectPalette(hDC,lphPal[CurrFile][CurrIcon],FALSE);
	  RealizePalette(hDC);

	  GetDIBits(hDC, lphXORBitmap[CurrFile][CurrIcon], 0, (WORD)lpBitmapinfo->bmiHeader.biHeight, (LPSTR)lpMem, (LPBITMAPINFO)lpBitmapinfo, DIB_RGB_COLORS);

	  pRgb = (RGBQUAD FAR *)((LPSTR)lpBitmapinfo->bmiColors);
	  pPal = (LOGPALETTE*)LocalAlloc(LPTR,sizeof(LOGPALETTE) + PalEntrys * sizeof(PALETTEENTRY));

	  if (!pPal)
	    return FALSE;

	  pPal->palNumEntries = PalEntrys;
	  pPal->palVersion    = 0x300;

	  for (i = 0; i < PalEntrys; i++)
	  {
	    pPal->palPalEntry[i].peRed   = pRgb[i].rgbRed;
	    pPal->palPalEntry[i].peGreen = pRgb[i].rgbGreen;
	    pPal->palPalEntry[i].peBlue  = pRgb[i].rgbBlue;
	    pPal->palPalEntry[i].peFlags = (BYTE)0;
	  }

	  lphPal[OtherFile][Quantity-1] = CreatePalette(pPal);
	  LocalFree((HANDLE)pPal);

	  lphXORBitmap[OtherFile][Quantity-1]=CreateDIBitmap(hDC,(LPBITMAPINFOHEADER)&(lpBitmapinfo->bmiHeader),CBM_INIT,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapinfo,DIB_RGB_COLORS);

	  ReleaseDC(NULL,hDC);
	  GlobalUnlock(hMem);
	  GlobalFree(hMem);
	  GlobalUnlock(hBitmapinfoMem);
	  GlobalFree(hBitmapinfoMem);
	  if (lphXORBitmap[OtherFile][Quantity-1])
	  {
	    Size1=CalcSize(lpResDir[CurrFile][CurrIcon].Width, lpResDir[CurrFile][CurrIcon].Height, 1);

	    if ((hMem = GlobalAlloc(GMEM_MOVEABLE,Size1)) != NULL)
	    {
	      if ((hBitmapinfoMem = GlobalAlloc(GMEM_MOVEABLE,sizeof(BITMAPINFOHEADER)+2*sizeof(RGBQUAD))) != NULL)
	      {
		if((lpMem = GlobalLock(hMem)) != (LPSTR) NULL)
		{
		  if((lpBitmapinfo = (LPBITMAPINFO)GlobalLock(hBitmapinfoMem)) != NULL)
		  {
		    lpBitmapinfo->bmiHeader.biSize=(long)sizeof(BITMAPINFOHEADER);
		    lpBitmapinfo->bmiHeader.biWidth=lpResDir[CurrFile][CurrIcon].Width;
		    lpBitmapinfo->bmiHeader.biHeight=lpResDir[CurrFile][CurrIcon].Height;
		    lpBitmapinfo->bmiHeader.biPlanes=1;
		    lpBitmapinfo->bmiHeader.biBitCount=1;
		    lpBitmapinfo->bmiHeader.biCompression=0L;
		    lpBitmapinfo->bmiHeader.biSizeImage=0L;
		    lpBitmapinfo->bmiHeader.biXPelsPerMeter=0L;
		    lpBitmapinfo->bmiHeader.biYPelsPerMeter=0L;
		    lpBitmapinfo->bmiHeader.biClrUsed=0L;
		    lpBitmapinfo->bmiHeader.biClrImportant=0L;
		    lpBitmapinfo->bmiColors[0].rgbRed=0;
		    lpBitmapinfo->bmiColors[0].rgbGreen=0;
		    lpBitmapinfo->bmiColors[0].rgbBlue=0;
		    lpBitmapinfo->bmiColors[1].rgbRed=0xff;
		    lpBitmapinfo->bmiColors[1].rgbGreen=0xff;
		    lpBitmapinfo->bmiColors[1].rgbBlue=0xff;

		    hDC=GetDC(NULL);

		    GetDIBits(hDC, lphANDBitmap[CurrFile][CurrIcon], 0, (WORD)lpBitmapinfo->bmiHeader.biHeight, (LPSTR)lpMem, (LPBITMAPINFO)lpBitmapinfo, DIB_RGB_COLORS);

		    lphANDBitmap[OtherFile][Quantity-1] = CreateDIBitmap(hDC,(LPBITMAPINFOHEADER)&(lpBitmapinfo->bmiHeader),CBM_INIT,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapinfo, DIB_RGB_COLORS);
		    ReleaseDC(NULL,hDC);
		    GlobalUnlock(hBitmapinfoMem);
		    GlobalUnlock(hMem);
		    GlobalFree(hBitmapinfoMem);
		    GlobalFree(hMem);
		  }
		}
	      }
	    }
	  }
	  else
	  {
	    MessageBox(hWnd, "Bitmap konnte nicht erstellt werden !" ,NULL,MB_OK|MB_ICONHAND);
	    return FALSE;
	  }
	}
      }
    }
  }

  return TRUE;
}

BOOL SaveIconFile2(lphXORBmpMem,lphANDBmpMem,lphPalMem,lphResDirMem,hFile, hWnd, Quantity, Ver20)
HANDLE FAR *lphXORBmpMem;
HANDLE FAR *lphANDBmpMem;
HANDLE FAR *lphPalMem;
HANDLE FAR *lphResDirMem;
HANDLE hFile;
HWND hWnd;
WORD Quantity;
BOOL Ver20;
{

  HBITMAP FAR *lphXORBitmap;
  HBITMAP FAR *lphANDBitmap;
  HPALETTE FAR *lphPal;
  ICONRESOURCE FAR *lpResDir;
  BITMAPARRAYFILEHEADER2 BitmapArrayFileHeader2;
  BITMAPFILEHEADER2 BitmapFileHeader2;
  DWORD count=0;
  DWORD count1;
  DWORD Groesse;
  DWORD Result;
  DWORD Result1;
  WORD CoreSize;
  WORD RGBSize;

  if (hFile)
  {
    lphXORBitmap = (HBITMAP FAR*)GlobalLock((HANDLE)*lphXORBmpMem);
    lphANDBitmap = (HBITMAP FAR*)GlobalLock((HANDLE)*lphANDBmpMem);
    lphPal = (HPALETTE FAR*)GlobalLock((HANDLE)*lphPalMem);
    lpResDir = (ICONRESOURCE FAR*)GlobalLock((HANDLE)*lphResDirMem);

    if(Ver20)
    {
      CoreSize=sizeof(BITMAPCOREHEADER2);
      RGBSize=sizeof(RGBQUAD);
    }
    else
    {
      CoreSize=sizeof(BITMAPCOREHEADER);
      RGBSize=sizeof(RGBTRIPLE);
    }

    count1=Quantity*(sizeof(BITMAPARRAYFILEHEADER2)+2*sizeof(BITMAPFILEHEADER2)+2*CoreSize+2*RGBSize);
    for (i=0;i<Quantity;i++) count1+=(lpResDir[i].ColorCount+256*lpResDir[i].Reserved1)*RGBSize;

    for (i=0;i<Quantity;i++)
    {
      Groesse=CalcSize(lpResDir[i].Width, lpResDir[i].Height, 1);

      Groesse*=2;

      Result1=SaveIcon2(lphXORBitmap[i],
		      lphANDBitmap[i],
		      lphPal[i],
		      count1+Groesse,
		      count1,
		      count+CoreSize+2*RGBSize+2*sizeof(BITMAPFILEHEADER2)+sizeof(BITMAPARRAYFILEHEADER2),
		      count+sizeof(BITMAPARRAYFILEHEADER2)+sizeof(BITMAPFILEHEADER2),
		      hFile,
		      hWnd,
		      (WORD)ColBit(lpResDir[i].ColorCount+256*lpResDir[i].Reserved1),
		      Ver20);

      BitmapArrayFileHeader2.usType=0x4142;
      BitmapArrayFileHeader2.cbSize=sizeof(BITMAPARRAYFILEHEADER2)+sizeof(BITMAPFILEHEADER2)+CoreSize;

      if(Quantity==(i+1))
	BitmapArrayFileHeader2.offNext=0;
      else
	BitmapArrayFileHeader2.offNext=(count+sizeof(BITMAPARRAYFILEHEADER2)+2*sizeof(BITMAPFILEHEADER2)+2*CoreSize+RGBSize*(2+lpResDir[i].ColorCount+256*lpResDir[i].Reserved1));

      BitmapArrayFileHeader2.cxDisplay=0;
      BitmapArrayFileHeader2.cyDisplay=0;

      _llseek(hFile,count,0);

      Result=_lwrite(hFile,(LPSTR)&BitmapArrayFileHeader2,sizeof(BITMAPARRAYFILEHEADER2));
      count+=Result;

      if(Result!=sizeof(BITMAPARRAYFILEHEADER2))
      {
	MessageBox(hWnd,"Nicht gengend freier Speicher auf Laufwerk!",NULL,MB_OK|MB_ICONHAND);
	GlobalUnlock((HANDLE)*lphXORBmpMem);
	GlobalUnlock((HANDLE)*lphANDBmpMem);
	GlobalUnlock((HANDLE)*lphPalMem);
	GlobalUnlock((HANDLE)*lphResDirMem);
	return FALSE;
      }

      BitmapFileHeader2.usType=0x4943;
      BitmapFileHeader2.cbSize=sizeof(BITMAPFILEHEADER2)+CoreSize;
      BitmapFileHeader2.xHotspot=lpResDir[i].Width/2;
      BitmapFileHeader2.yHotspot=lpResDir[i].Height/2;
      BitmapFileHeader2.offBits=count1;

      _llseek(hFile,count,0);

      Result=_lwrite(hFile,(LPSTR)&BitmapFileHeader2,sizeof(BITMAPFILEHEADER2));
      count+=Result;

      if(Result!=sizeof(BITMAPFILEHEADER2))
      {
	MessageBox(hWnd,"Nicht gengend freier Speicher auf Laufwerk!",NULL,MB_OK|MB_ICONHAND);
	GlobalUnlock((HANDLE)*lphXORBmpMem);
	GlobalUnlock((HANDLE)*lphANDBmpMem);
	GlobalUnlock((HANDLE)*lphPalMem);
	GlobalUnlock((HANDLE)*lphResDirMem);
	return FALSE;
      }

      count+=CoreSize+2*RGBSize;

      BitmapFileHeader2.offBits=count1+Groesse;

      _llseek(hFile,count,0);

      Result=_lwrite(hFile,(LPSTR)&BitmapFileHeader2,sizeof(BITMAPFILEHEADER2));
      count+=Result;

      if(Result!=sizeof(BITMAPFILEHEADER2))
      {
	MessageBox(hWnd,"Nicht gengend freier Speicher auf Laufwerk!",NULL,MB_OK|MB_ICONHAND);
	GlobalUnlock((HANDLE)*lphXORBmpMem);
	GlobalUnlock((HANDLE)*lphANDBmpMem);
	GlobalUnlock((HANDLE)*lphPalMem);
	GlobalUnlock((HANDLE)*lphResDirMem);
	return FALSE;
      }

      count+=CoreSize+(lpResDir[i].ColorCount+256*lpResDir[i].Reserved1)*RGBSize;
      count1+=Result1;
    }

    GlobalUnlock((HANDLE)*lphXORBmpMem);
    GlobalUnlock((HANDLE)*lphANDBmpMem);
    GlobalUnlock((HANDLE)*lphPalMem);
    GlobalUnlock((HANDLE)*lphResDirMem);
    return TRUE;
  }

  return FALSE;
}


DWORD SaveIcon2(hXORBitmap, hANDBitmap, hPal, BegPosData1, BegPosData2, BegPosInfo1, BegPosInfo2, hFile, hWnd, BitPix, Ver20)
HBITMAP hXORBitmap;
HBITMAP hANDBitmap;
HPALETTE hPal;
DWORD BegPosData1;
DWORD BegPosData2;
DWORD BegPosInfo1;
DWORD BegPosInfo2;
WORD hFile;
HWND hWnd;
WORD BitPix;
BOOL Ver20;
{
  HDC hDC;
  DWORD Size=0;
  DWORD Groesse=0;
  DWORD Size1=0;
  DWORD Size2=0;
  DWORD Groesse1=0;
  LPBITMAPINFO lpBitmapInfo;
  LPBITMAPCOREINFO lpBitmapCoreInfo;
  LPBITMAPCOREINFO2 lpBitmapCoreInfo2;
  LPSTR lpMem;
  HANDLE hBitmapCoreInfoMem;
  HANDLE hBitmapInfoMem;
  HANDLE hMem;
  int count;
  WORD PalEntrys;
  BITMAP Bitmap;
  HBITMAP hXORBitmap2;
  int i;
  int j;

  HDC hDC1;
  HDC hDC2;
  HDC hDC3;
  HBITMAP hOldBitmap1;
  HBITMAP hOldBitmap2;
  HBITMAP hOldBitmap3;
  LPSTR lpResult;
  WORD CoreSize;
  WORD RGBSize;

  if(Ver20)
  {
    CoreSize=sizeof(BITMAPCOREHEADER2);
    RGBSize=sizeof(RGBQUAD);
  }
  else
  {
    CoreSize=sizeof(BITMAPCOREHEADER);
    RGBSize=sizeof(RGBTRIPLE);
  }

  GetObject(hXORBitmap,sizeof(BITMAP),(LPSTR)&Bitmap);
  GetObject(hPal,2,(LPSTR)&PalEntrys);
  Groesse = CoreSize+PalEntrys*RGBSize;

  if ((hBitmapCoreInfoMem = GlobalAlloc(GMEM_MOVEABLE,Groesse)) != NULL)
  {
    if((lpResult=GlobalLock(hBitmapCoreInfoMem))!= NULL)
    {
      hDC=GetDC(NULL);

      SelectPalette(hDC,hPal,0);
      RealizePalette(hDC);

      if(Ver20)
      {
	lpBitmapCoreInfo2=(LPBITMAPCOREINFO2)lpResult;
	if ((hBitmapInfoMem = GlobalAlloc(GMEM_MOVEABLE,sizeof(BITMAPINFOHEADER)+PalEntrys*sizeof(RGBQUAD))) != NULL)
	{
	  if((lpBitmapInfo=(LPBITMAPINFO)GlobalLock(hBitmapInfoMem))!= NULL)
	  {
	    lpBitmapInfo->bmiHeader.biSize=(long)sizeof(BITMAPINFOHEADER);
	    lpBitmapInfo->bmiHeader.biWidth=Bitmap.bmWidth;
	    lpBitmapInfo->bmiHeader.biHeight=Bitmap.bmHeight;
	    lpBitmapInfo->bmiHeader.biPlanes=1;
	    lpBitmapInfo->bmiHeader.biBitCount=BitPix;
	    lpBitmapInfo->bmiHeader.biCompression = 0;
	    lpBitmapInfo->bmiHeader.biSizeImage = 0;
	    lpBitmapInfo->bmiHeader.biXPelsPerMeter = 0;
	    lpBitmapInfo->bmiHeader.biYPelsPerMeter = 0;
	    lpBitmapInfo->bmiHeader.biClrUsed = 0;
	    lpBitmapInfo->bmiHeader.biClrImportant = 0;

	    GetDIBits(hDC,hXORBitmap,0,(WORD)lpBitmapInfo->bmiHeader.biHeight,NULL,(LPBITMAPINFO)lpBitmapInfo,DIB_RGB_COLORS);
	    Size = CalcSize((WORD)lpBitmapInfo->bmiHeader.biWidth, (WORD)lpBitmapInfo->bmiHeader.biHeight, lpBitmapInfo->bmiHeader.biBitCount);

	    GlobalUnlock(hBitmapInfoMem);
	  }
	}
      }
      else
      {
	lpBitmapCoreInfo=(LPBITMAPCOREINFO)lpResult;
	lpBitmapCoreInfo->bmciHeader.bcSize = CoreSize;
	lpBitmapCoreInfo->bmciHeader.bcWidth = Bitmap.bmWidth;
	lpBitmapCoreInfo->bmciHeader.bcHeight = Bitmap.bmHeight;
	lpBitmapCoreInfo->bmciHeader.bcPlanes = 1;
	lpBitmapCoreInfo->bmciHeader.bcBitCount = BitPix;

	GetDIBits(hDC,hXORBitmap,0,(WORD)lpBitmapCoreInfo->bmciHeader.bcHeight,NULL,(LPBITMAPINFO)lpBitmapCoreInfo,DIB_RGB_COLORS);
	Size = CalcSize(lpBitmapCoreInfo->bmciHeader.bcWidth, lpBitmapCoreInfo->bmciHeader.bcHeight, lpBitmapCoreInfo->bmciHeader.bcBitCount);
      }

      if ((hMem = GlobalAlloc(GMEM_MOVEABLE,Size)) != NULL)
      {
	if((lpMem = GlobalLock(hMem)) != (LPSTR) NULL)
	{
	  if(Ver20)
	  {
	    if((lpBitmapInfo=(LPBITMAPINFO)GlobalLock(hBitmapInfoMem))!= NULL)
	    {
	      count = GetDIBits(hDC,hXORBitmap,0,(WORD)lpBitmapInfo->bmiHeader.biHeight,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapInfo,DIB_RGB_COLORS);

	      lpBitmapCoreInfo2->bmciHeader.cbFix=(long)sizeof(BITMAPCOREHEADER2);
	      lpBitmapCoreInfo2->bmciHeader.cx=lpBitmapInfo->bmiHeader.biWidth;
	      lpBitmapCoreInfo2->bmciHeader.cy=lpBitmapInfo->bmiHeader.biHeight;
	      lpBitmapCoreInfo2->bmciHeader.cPlanes=lpBitmapInfo->bmiHeader.biPlanes;
	      lpBitmapCoreInfo2->bmciHeader.cBitCount=lpBitmapInfo->bmiHeader.biBitCount;
	      lpBitmapCoreInfo2->bmciHeader.ulCompression=lpBitmapInfo->bmiHeader.biCompression;
	      lpBitmapCoreInfo2->bmciHeader.cbImage=lpBitmapInfo->bmiHeader.biSizeImage;
	      lpBitmapCoreInfo2->bmciHeader.cxResolution=lpBitmapInfo->bmiHeader.biXPelsPerMeter;
	      lpBitmapCoreInfo2->bmciHeader.cyResolution=lpBitmapInfo->bmiHeader.biYPelsPerMeter;
	      lpBitmapCoreInfo2->bmciHeader.cclrUsed=lpBitmapInfo->bmiHeader.biClrUsed;
	      lpBitmapCoreInfo2->bmciHeader.cclrImportant=lpBitmapInfo->bmiHeader.biClrImportant;
	      lpBitmapCoreInfo2->bmciHeader.usUnits=0;
	      lpBitmapCoreInfo2->bmciHeader.usReserved=0;
	      lpBitmapCoreInfo2->bmciHeader.usRecording=0;
	      lpBitmapCoreInfo2->bmciHeader.usRendering=0;
	      lpBitmapCoreInfo2->bmciHeader.cSize1=0;
	      lpBitmapCoreInfo2->bmciHeader.cSize2=0;
	      lpBitmapCoreInfo2->bmciHeader.ulColorEncoding=0;
	      lpBitmapCoreInfo2->bmciHeader.ulIdentifier=0;
	      for (i = 0; i < PalEntrys; i++)
	      {
		lpBitmapCoreInfo2->bmciColors[i].rgbRed= lpBitmapInfo->bmiColors[i].rgbRed;
		lpBitmapCoreInfo2->bmciColors[i].rgbGreen= lpBitmapInfo->bmiColors[i].rgbGreen;
		lpBitmapCoreInfo2->bmciColors[i].rgbBlue= lpBitmapInfo->bmiColors[i].rgbBlue;
		lpBitmapCoreInfo2->bmciColors[i].rgbReserved= lpBitmapInfo->bmiColors[i].rgbReserved;
	      }

	      GlobalUnlock(hBitmapInfoMem);
	      GlobalFree(hBitmapInfoMem);
	    }
	  }
	  else
	    count = GetDIBits(hDC,hXORBitmap,0,(WORD)lpBitmapCoreInfo->bmciHeader.bcHeight,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapCoreInfo,DIB_RGB_COLORS);

	  ReleaseDC(NULL,hDC);

	  if(BegPosInfo1!=0)
	  {
	    _llseek(hFile,BegPosInfo1,0);

	    if((Groesse=_lwrite(hFile,(Ver20?(LPSTR)lpBitmapCoreInfo2:(LPSTR)lpBitmapCoreInfo),(WORD)Groesse))!=Groesse)
	    {
	      MessageBox(hWnd,"Nicht gengend freier Speicher auf Laufwerk!",NULL,MB_OK|MB_ICONHAND);
	      GlobalUnlock(hMem);
	      GlobalFree(hMem);
	      GlobalUnlock(hBitmapCoreInfoMem);
	      GlobalFree(hBitmapCoreInfoMem);
	      return(FALSE);
	    }
	  }

	  if(BegPosData1!=0)
	  {
	    _llseek(hFile,BegPosData1,0);

	    if((Size=_lwrite(hFile,lpMem,(WORD)Size))!=Size)
	    {
	      MessageBox(hWnd,"Nicht gengend freier Speicher auf Laufwerk!",NULL,MB_OK|MB_ICONHAND);
	      GlobalUnlock(hMem);
	      GlobalFree(hMem);
	      GlobalUnlock(hBitmapCoreInfoMem);
	      GlobalFree(hBitmapCoreInfoMem);
	      return(FALSE);
	    }
	  }

	  GlobalUnlock(hMem);
	  GlobalFree(hMem);
	  GlobalUnlock(hBitmapCoreInfoMem);
	  GlobalFree(hBitmapCoreInfoMem);
	  GetObject(hXORBitmap,sizeof(BITMAP),(LPSTR)&Bitmap);

	  Size1=CalcSize(Bitmap.bmWidth, Bitmap.bmHeight, 1);

	  Size2=Size1;

	  Groesse1=CoreSize+2*RGBSize;

	  if ((hMem = GlobalAlloc(GMEM_MOVEABLE,Size1)) != NULL)
	  {
	    if((lpMem = GlobalLock(hMem)) != (LPSTR) NULL)
	    {
	      if ((hBitmapCoreInfoMem = GlobalAlloc(GMEM_MOVEABLE,Groesse1)) != NULL)
	      {
		if((lpResult=GlobalLock(hBitmapCoreInfoMem))!= NULL)
		{
		  hDC=GetDC(NULL);
		  if(Ver20)
		  {
		    lpBitmapCoreInfo2=(LPBITMAPCOREINFO2)lpResult;

		    if ((hBitmapInfoMem = GlobalAlloc(GMEM_MOVEABLE,sizeof(BITMAPINFOHEADER)+2*sizeof(RGBQUAD))) != NULL)
		    {
		      if((lpBitmapInfo = (LPBITMAPINFO)GlobalLock(hBitmapInfoMem)) != NULL)
		      {
			lpBitmapInfo->bmiHeader.biSize=(long)sizeof(BITMAPINFOHEADER);
			lpBitmapInfo->bmiHeader.biWidth=Bitmap.bmWidth;
			lpBitmapInfo->bmiHeader.biHeight=Bitmap.bmHeight;
			lpBitmapInfo->bmiHeader.biPlanes=1;
			lpBitmapInfo->bmiHeader.biBitCount=1;
			lpBitmapInfo->bmiHeader.biCompression=0L;
			lpBitmapInfo->bmiHeader.biSizeImage=0L;
			lpBitmapInfo->bmiHeader.biXPelsPerMeter=0L;
			lpBitmapInfo->bmiHeader.biYPelsPerMeter=0L;
			lpBitmapInfo->bmiHeader.biClrUsed=0L;
			lpBitmapInfo->bmiHeader.biClrImportant=0L;
			lpBitmapInfo->bmiColors[0].rgbRed=0;
			lpBitmapInfo->bmiColors[0].rgbGreen=0;
			lpBitmapInfo->bmiColors[0].rgbBlue=0;
			lpBitmapInfo->bmiColors[1].rgbRed=0xff;
			lpBitmapInfo->bmiColors[1].rgbGreen=0xff;
			lpBitmapInfo->bmiColors[1].rgbBlue=0xff;

			hXORBitmap2 = CreateDIBitmap(hDC,(LPBITMAPINFOHEADER)&(lpBitmapInfo->bmiHeader),CBM_INIT,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapInfo, DIB_RGB_COLORS);

			lpBitmapCoreInfo2->bmciHeader.cbFix=(long)sizeof(BITMAPCOREHEADER2);
			lpBitmapCoreInfo2->bmciHeader.cx=lpBitmapInfo->bmiHeader.biWidth;
			lpBitmapCoreInfo2->bmciHeader.cy=lpBitmapInfo->bmiHeader.biHeight*2;
			lpBitmapCoreInfo2->bmciHeader.cPlanes=lpBitmapInfo->bmiHeader.biPlanes;
			lpBitmapCoreInfo2->bmciHeader.cBitCount=lpBitmapInfo->bmiHeader.biBitCount;
			lpBitmapCoreInfo2->bmciHeader.ulCompression=lpBitmapInfo->bmiHeader.biCompression;
			lpBitmapCoreInfo2->bmciHeader.cbImage=lpBitmapInfo->bmiHeader.biSizeImage;
			lpBitmapCoreInfo2->bmciHeader.cxResolution=lpBitmapInfo->bmiHeader.biXPelsPerMeter;
			lpBitmapCoreInfo2->bmciHeader.cyResolution=lpBitmapInfo->bmiHeader.biYPelsPerMeter;
			lpBitmapCoreInfo2->bmciHeader.cclrUsed=lpBitmapInfo->bmiHeader.biClrUsed;
			lpBitmapCoreInfo2->bmciHeader.cclrImportant=lpBitmapInfo->bmiHeader.biClrImportant;
			lpBitmapCoreInfo2->bmciHeader.usUnits=0;
			lpBitmapCoreInfo2->bmciHeader.usReserved=0;
			lpBitmapCoreInfo2->bmciHeader.usRecording=0;
			lpBitmapCoreInfo2->bmciHeader.usRendering=0;
			lpBitmapCoreInfo2->bmciHeader.cSize1=0;
			lpBitmapCoreInfo2->bmciHeader.cSize2=0;
			lpBitmapCoreInfo2->bmciHeader.ulColorEncoding=0;
			lpBitmapCoreInfo2->bmciHeader.ulIdentifier=0;
			for (i = 0; i < 2; i++)
			{
			  lpBitmapCoreInfo2->bmciColors[i].rgbRed= lpBitmapInfo->bmiColors[i].rgbRed;
			  lpBitmapCoreInfo2->bmciColors[i].rgbGreen= lpBitmapInfo->bmiColors[i].rgbGreen;
			  lpBitmapCoreInfo2->bmciColors[i].rgbBlue= lpBitmapInfo->bmiColors[i].rgbBlue;
			  lpBitmapCoreInfo2->bmciColors[i].rgbReserved= lpBitmapInfo->bmiColors[i].rgbReserved;
			}

			GlobalUnlock(hBitmapInfoMem);
		      }
		    }
		  }
		  else
		  {
		    lpBitmapCoreInfo=(LPBITMAPCOREINFO)lpResult;
		    lpBitmapCoreInfo->bmciHeader.bcSize=(long)sizeof(BITMAPCOREHEADER);
		    lpBitmapCoreInfo->bmciHeader.bcWidth=Bitmap.bmWidth;
		    lpBitmapCoreInfo->bmciHeader.bcHeight=Bitmap.bmHeight;
		    lpBitmapCoreInfo->bmciHeader.bcPlanes=1;
		    lpBitmapCoreInfo->bmciHeader.bcBitCount=1;
		    lpBitmapCoreInfo->bmciColors[0].rgbtRed=0;
		    lpBitmapCoreInfo->bmciColors[0].rgbtGreen=0;
		    lpBitmapCoreInfo->bmciColors[0].rgbtBlue=0;
		    lpBitmapCoreInfo->bmciColors[1].rgbtRed=0xff;
		    lpBitmapCoreInfo->bmciColors[1].rgbtGreen=0xff;
		    lpBitmapCoreInfo->bmciColors[1].rgbtBlue=0xff;

		    hXORBitmap2 = CreateDIBitmap(hDC,(LPBITMAPINFOHEADER)&(lpBitmapCoreInfo->bmciHeader),CBM_INIT,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapCoreInfo, DIB_RGB_COLORS);
		  }

		  hDC1=CreateCompatibleDC(hDC);
		  hDC2=CreateCompatibleDC(hDC);
		  hDC3=CreateCompatibleDC(hDC);

		  hOldBitmap1=SelectObject(hDC1,hXORBitmap);
		  hOldBitmap2=SelectObject(hDC2,hANDBitmap);
		  hOldBitmap3=SelectObject(hDC3,hXORBitmap2);

		  for(i=0;i<Bitmap.bmWidth;i++)
		  {
		    for(j=0;j<Bitmap.bmHeight;j++)
		    {
		      if(GetPixel(hDC2,i,j)==RGB(255,255,255))
			SetPixel(hDC3,i,j,GetPixel(hDC1,i,j));
		      else
			SetPixel(hDC3,i,j,RGB(0,0,0));
		    }
		  }

		  SelectObject(hDC1,hOldBitmap1);
		  SelectObject(hDC2,hOldBitmap2);
		  SelectObject(hDC3,hOldBitmap3);

		  DeleteDC(hDC1);
		  DeleteDC(hDC2);
		  DeleteDC(hDC3);

		  if(Ver20)
		  {
		    if((lpBitmapInfo = (LPBITMAPINFO)GlobalLock(hBitmapInfoMem)) != NULL)
		    {
		      count = GetDIBits(hDC,hXORBitmap2,0,(WORD)lpBitmapInfo->bmiHeader.biHeight,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapInfo,DIB_RGB_COLORS);
		      GlobalUnlock(hBitmapInfoMem);
		    }
		  }
		  else
		  {
		    count = GetDIBits(hDC,hXORBitmap2,0,(WORD)lpBitmapCoreInfo->bmciHeader.bcHeight,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapCoreInfo,DIB_RGB_COLORS);
		    lpBitmapCoreInfo->bmciHeader.bcHeight*=2;
		  }

		  if(BegPosInfo2!=0)
		  {
		    _llseek(hFile,BegPosInfo2,0);

		    if((Groesse1=_lwrite(hFile,(Ver20?(LPSTR)lpBitmapCoreInfo2:(LPSTR)lpBitmapCoreInfo),(WORD)Groesse1))!=Groesse1)
		    {
		      MessageBox(hWnd,"Nicht gengend freier Speicher auf Laufwerk!",NULL,MB_OK|MB_ICONHAND);
		      GlobalUnlock(hMem);
		      GlobalFree(hMem);
		      GlobalUnlock(hBitmapCoreInfoMem);
		      GlobalFree(hBitmapCoreInfoMem);
		      return(FALSE);
		    }
		  }

		  if(BegPosData2!=0)
		  {
		    _llseek(hFile,BegPosData2,0);

		    if((Size1=_lwrite(hFile,(LPSTR)lpMem,(WORD)Size1))!=Size1)
		    {
		      MessageBox(hWnd,"Nicht gengend freier Speicher auf Laufwerk!",NULL,MB_OK|MB_ICONHAND);
		      GlobalUnlock(hBitmapCoreInfoMem);
		      GlobalUnlock(hMem);
		      GlobalFree(hBitmapCoreInfoMem);
		      GlobalFree(hMem);
		      return (FALSE);
		    }

		    if(Ver20)
		    {
		      if((lpBitmapInfo = (LPBITMAPINFO)GlobalLock(hBitmapInfoMem)) != NULL)
		      {
			count = GetDIBits(hDC,hANDBitmap,0,(WORD)lpBitmapInfo->bmiHeader.biHeight,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapInfo,DIB_RGB_COLORS);
			GlobalUnlock(hBitmapInfoMem);
			GlobalFree(hBitmapInfoMem);
		      }
		    }
		    else
		    {
		      lpBitmapCoreInfo->bmciHeader.bcHeight/=2;
		      count = GetDIBits(hDC,hANDBitmap,0,(WORD)lpBitmapCoreInfo->bmciHeader.bcHeight,(LPSTR)lpMem,(LPBITMAPINFO)lpBitmapCoreInfo,DIB_RGB_COLORS);
		    }

		    if((Size2=_lwrite(hFile,(LPSTR)lpMem,(WORD)Size2))!=Size2)
		    {
		      MessageBox(hWnd,"Nicht gengend freier Speicher auf Laufwerk!",NULL,MB_OK|MB_ICONHAND);
		      GlobalUnlock(hBitmapCoreInfoMem);
		      GlobalUnlock(hMem);
		      GlobalFree(hBitmapCoreInfoMem);
		      GlobalFree(hMem);
		      return (FALSE);
		    }
		  }

		  ReleaseDC(NULL,hDC);

		  GlobalUnlock(hBitmapCoreInfoMem);
		  GlobalUnlock(hMem);
		  GlobalFree(hBitmapCoreInfoMem);
		  GlobalFree(hMem);
		}
	      }
	    }
	  }
	}
      }
    }
  }
  return (Size+Size1+Size2);
}

DWORD CalcSize(Width, Height, BitPix)
WORD Width;
WORD Height;
WORD BitPix;
{
  DWORD Size;
  DWORD OverBound;

  Size = Width*Height*BitPix/8;
  OverBound=(Width*BitPix)%(sizeof(LONG)*8);
  if(OverBound) Size+=(sizeof(LONG)*8-OverBound)*Height/8;
  return(Size);
}

/* ------------------------------------------------- */
/*                   Ende von ICON.C                 */
