/* TEST.C - Demoprogramm fr die Ansteuerung der Audio 
 *          Funktionen des CD Laufwerkes.
 *   Beschreibung der aufgerufenen Funktionen in audio.h!
 *    (c) 1992 U. Killermann und TOOLBOX
 *
 * Getestet mit Borland C++ 3.0
 */
#include <stdio.h>
#include "audio.h"

void help(void)
{
  fprintf(stderr,"Testprogramm fr audio.c \n");
  fprintf(stderr,"(c) 1992 U. Killermann und TOOLBOX \n");
  fprintf(stderr,"Optionen:\n");
  fprintf(stderr,"\tS     : Start/Stop abspielen\n");
  fprintf(stderr,"\tP     : Pause ein- und ausschalten\n");
  fprintf(stderr,"\tnn    : Direktanwahl Titel (1-99)\n");
  fprintf(stderr,"\t+     : Springen zum nchsten Titel\n");
  fprintf(stderr,"\t-     : Springen zum vorigen Titel\n");
  fprintf(stderr,"\t.     : Aktuellen Titel wiederholen\n");
  fprintf(stderr,"\t)     : Springen +15 Sekunden\n");
  fprintf(stderr,"\t(     : Springen -15 Sekunden\n");
}

main(int argc, char * argv[])
{
  int ntitles;    /* Anzahl der Titel */
  int title;    /* Angewhlter Titel */
  int actual;   /* Aktueller Titel */

  if (argc==1) {    /* Richtige Anzahl von Argumenten ? */
    help();   /* Anzeigen des Hilfetextes */
    exit(0);
  }

 /* Laufwerk initialisieren und Anzahl der Stcke ermitteln */
  ntitles=init_CDAudio();
  if(ntitles<=0) {
    fprintf(stderr,"Fehler bei Laufwerksinitialisierung !\n");
    exit(-1);
  }
  
  title=atoi(argv[1]);  /* Titel direkt gewhlt ? */
  if(title>ntitles) {   /* Haben wir berhaupt soviele Stcke ? */
    fprintf(stderr,"Auf dieser CD sind nur %d Titel !\n",ntitles);
    exit(-1);
  }

  actual=get_actual_track(); /* Was wird hier gespielt ?*/

  if (title)           /* Wenn direkt gewhlt, dann von */
  {                    /* Wahltitel bis letztem Titel   */
    Stop_Audio();      /* abspielen.                    */
    Play_Tracks(title, ntitles);
  }
  else /* Kommandozeilenparamter berprfen */
    switch(toupper(*argv[1])) { 

      case '+': /* Sprung zum nchsten Titel */
          title=(actual==ntitles)?1:actual+1;
          Stop_Audio(); 
          Play_Tracks(title,ntitles);
          break;

      case '-':      /* Sprung zum vorigen Titel */
          title=(actual==1)?ntitles:actual-1;
          Stop_Audio();
          Play_Tracks(title,ntitles);
          break;

      case '.':     /* Dasselbe nochmal */
          Stop_Audio();
          Play_Tracks(actual,ntitles);
          break;

      case 'P': /* Pause */
          if (audio_busy())
            Stop_Audio(); /* PAUSE */
          else
            Resume_Audio(); /* Weiter ! */
          break;

      case 'S': /* Start/Stop */
          if (audio_busy())
            Stop_Audio();
          else
            /* Alle Titel abspielen */ 
            Play_Tracks(1,ntitles); 
          break;

      case ')': /* Sprung +15 Sekunden */
          Skip_Audio(15*75);
          break;

      case '(': /* Sprung -15 Sekunden */
          Skip_Audio(-15*75);
          break;

      default:  /* Unbekannte Option -> Hilfe */
          fprintf(stderr,"\tUnbekannte Option  %s  !\n",
            argv[1]);
          help();
          break;
  }

  delay(300); /* Verzgerung, damit Q-Kanal Info stimmt ! */

  if (audio_busy())
    printf("Gespielt wird der %d. von %d Titeln !",
    get_actual_track(), ntitles);

  return(0);
}
