/**********************************************************/
/* which.cmd, Version 1.4b                                */
/*                                                        */
/* 'which' sucht nach derjenigen ausfhrbaren Datei, die  */
/* bei Aufruf aus dem aktuellen Pfad ausgefhrt wrde.    */
/*                                                        */
/* Basiert auf dem UNIX-Kommando 'which'.                 */
/*                                                        */
/* Aufruf: which [-?hla] [dateiname...]                   */
/*                                                        */
/*          -h, -? gibt diesen Hilfetext aus              */
/*          -a gibt ALLE passenden ausfhrb. Dateien aus  */
/*          -l Ausgabe im Langformat                      */
/*          ohne dateiname werden die Pfade in            */
/*                                      'PATH' ausgegeben */
/*                                                        */
/*                                                        */
/* (C) TM, April 1993                                     */
/**********************************************************/

SIGNAL ON HALT NAME ende

PARSE SOURCE betriebssystem typ prog
prog=RIGHT(prog,LENGTH(prog)-LASTPOS('\',prog))

cnt=1
IF (LINES()>0) THEN DO                 /* Aus stdin lesen */
  DO WHILE (LINES()>0)
    PARSE VALUE LINEIN() WITH parameter.cnt
    cnt=cnt+1
  END
  cnt=cnt-1
END
ELSE                     /* Kommandozeilenparameter lesen */
  PARSE ARG parameter.cnt

parameter.0=cnt; cnt=1


CALL Initialisierung
CALL InitialisiereInterneKommandos


DO UNTIL (cnt>=parameter.0)
  CALL ScanOptions parameter.cnt
  IF WORDS(parameter.cnt) = 0 THEN
    /* Pfadeintrge ausgeben */
    CALL ShowPath PfadListe
  ELSE DO                   /* Ausfhrbare Dateien suchen */
                               /* Fr alle Dateinamen...: */
    DO WHILE (ArgCnt <= WORDS(parameter.cnt))
      ParNo=ArgCnt
      dname=EntferneAnfuehrungszeichen(parameter.cnt)
      ArgCnt=ParNo
      erfolg='N'; alt_liste.0=0
      IF (POS(':',dname)=2) | (POS('\',dname)\=0) THEN
        /* Pfadangabe im Namen: */
        CALL SucheAbsoluteDateinamen dname
      ELSE
        CALL SucheDateienImPfad dname
    END
  END
  cnt=cnt+1
END

EXIT 0

/*--------------------------------------------------------*/
/*--------------------------------------------------------*/
/* Initialisierung von SysFileTree und der Pfadliste.     */
/*--------------------------------------------------------*/
Initialisierung:

IF (RxFuncQuery('SysFileTree')\=0) THEN
  CALL RxFuncAdd 'SysFileTree','RexxUtil','SysFileTree'

PfadListe=(VALUE('PATH',,'OS2ENVIRONMENT'))
PfadListe=TRANSLATE(PfadListe,' ',';')
/* Das aktuelle Verzeichnis wird immer zuerst durchsucht: */
IF  (STRIP(WORD(PfadListe,1),'T','\')\='.') THEN
  PfadListe='. 'PfadListe

RETURN

/*--------------------------------------------------------*/
/* InitialisiereInterneKommandos: Einlesen aller internen */
/* Kommandos von CMD.EXE oder OS2.EXE (4OS2).             */
/*--------------------------------------------------------*/
InitialisiereInterneKommandos:

cmdshell=VALUE('COMSPEC',,'OS2ENVIRONMENT')
cmdshell=RIGHT(cmdshell,LASTPOS('\',cmdshell))

IF (cmdshell\='OS2.EXE') & (cmdshell\='CMD.EXE') THEN DO
  CALL error prog': Warnung: Shell nicht erkannt,',
                                     'nehme ''CMD.EXE'' an.'
  cmdshell='CMD.EXE'
END
IF (cmdshell='OS2.EXE') THEN DO
  intern.1 =ALIAS;    intern.2 =BEEP;    intern.3 =CALL
  intern.4 =CANCEL;   intern.5 =CD;      intern.6=CDD
  intern.7 =CHCP;     intern.8 =CHDIR;   intern.9 =CLS
  intern.10=COLOR;    intern.11=COPY;    intern.12=DATE
  intern.13=DEL;      intern.14=DELAY;   intern.15=DESCRIBE
  intern.16=DETACH;   intern.17=DIR;     intern.18=DIRS
  intern.19=DPATH;    intern.20=DRAWBOX; intern.21=DRAWHLINE
  intern.22=DRAWVLINE; intern.23=ECHO;   intern.24=ECHOS
  intern.25=ENDLOCAL; intern.26=ERASE;   intern.27=ESET
  intern.28=EXCEPT;   intern.29=EXIT;    intern.30=FOR
  intern.31=FREE;     intern.32=GLOBAL;  intern.33=GOSUB
  intern.34=GOTO;     intern.35=HELP;    intern.36=HISTORY
  intern.37=IF;       intern.38=IFF;     intern.39=INKEY
  intern.40=INPUT;    intern.41=KEYS;    intern.42=LIST
  intern.43=LOADBTM;  intern.44=LOG;     intern.45=MD
  intern.46=MEMORY;   intern.47=MKDIR;   intern.48=MOVE
  intern.49=PATH;     intern.50=PAUSE;   intern.51=POPD
  intern.52=PROMPT;   intern.53=PUSHD;   intern.54=QUIT
  intern.55=RD;       intern.56=REBOOT;  intern.57=REM
  intern.58=REN;      intern.59=RENAME;  intern.60=RETURN
  intern.61=RMDIR;    intern.62=SCREEN;  intern.63=SCRPUT
  intern.64=SELECT;   intern.65=SET;     intern.66=SETDOS
  intern.67=SETLOCAL; intern.68=SHIFT;   intern.69=START
  intern.70=TEE;      intern.71=TEXT;    intern.72=TIME
  intern.73=TIMER;    intern.74=TYPE;    intern.75=UNALIAS
  intern.76=UNSET;    intern.77=VER;     intern.78=VERIFY
  intern.79=VOL;      intern.80=VSCRPUT; intern.81=WINDOW
  intern.82=Y
  intern.0=82   /* Anzahl der internen (4OS2.EXE) Befehle */
END
ELSE DO
  intern.1 =CALL;     intern.2 =CD;      intern.3 =CHCP
  intern.4 =CHDIR;    intern.5 =CLS;     intern.6 =COPY
  intern.7 =DATE;     intern.8 =DEL;     intern.9 =DETACH
  intern.10=DIR;      intern.11=DPATH;   intern.12=ECHO
  intern.13=ENDLOCAL; intern.14=ERASE;   intern.15=EXIT
  intern.16=EXTPROC;  intern.17=FOR;     intern.18=GOTO
  intern.19=IF;       intern.20=KEYS;    intern.21=MD
  intern.22=MKDIR;    intern.23=MOVE;    intern.24=PATH
  intern.25=PAUSE;    intern.26=PROMPT;  intern.27=RD
  intern.28=REM;      intern.29=REN;     intern.30=RENAME
  intern.31=RMDIR;    intern.32=SET;     intern.33=SETLOCAL
  intern.34=SHIFT;    intern.35=START;   intern.36=TIME
  intern.37=TYPE;     intern.38=VER;     intern.39=VERIFY
  intern.40=VOL
  intern.0=40    /* Anzahl der internen (CMD.EXE) Befehle */
END

RETURN

/*--------------------------------------------------------*/
/* ShowPath gibt alle Pfadeintrge aus.                   */
/*--------------------------------------------------------*/
ShowPath: PROCEDURE EXPOSE prog
  PARSE ARG Pfade

  ParNo=1
  DO WHILE (ParNo <= WORDS(Pfade))
    SAY EntferneAnfuehrungszeichen(Pfade)
  END
  RETURN

/*--------------------------------------------------------*/
/* SucheAbsoluteDateinamen sucht nach der spezifizierten  */
/* Datei, wenn sie eine Pfad- oder Laufwerksangabe ent=   */
/* hlt.                                                  */
/*--------------------------------------------------------*/
SucheAbsoluteDateinamen:
  PARSE ARG Aname

  IF (SucheDatei(Aname,'A')='W') THEN
    IF (SucheDatei(Aname'.COM','S')='W') THEN
      IF (SucheDatei(Aname'.EXE','S')='W') THEN
        IF (cmdshell\='OS2.EXE') |,
           (SucheDatei(Aname'.BTM','S')='W') THEN
          IF (SucheDatei(Aname'.CMD','S')='W') THEN
            CALL SucheDatei Aname'.BAT','S'
  DROP alt_liste.
  IF erfolg='N' THEN DO
    CALL error prog': '''Aname''' nicht gefunden.'
  END

  RETURN

/*--------------------------------------------------------*/
/* SucheDateienImPfad sucht nach allen passenden Dateien  */
/* in den Pfaden der PATH-Variablen.                      */
/*--------------------------------------------------------*/
SucheDateienImPfad:
  PARSE ARG Pname

  IF (cmdshell='OS2.EXE') THEN DO
    /* 4OS2, Aliases haben hchste Prioritt: */
    IF (SucheAlias(Pname)='Q') THEN RETURN
  END

  /* Interne Befehle haben hchste Prioritt: */
  IF (SucheInternesKommando(Pname)='Q') THEN RETURN

  /* Suche in allen Pfaden von PATH...: */
  parcnt=1
  DO WHILE (parcnt <= WORDS(PfadListe))
    ParNo=parcnt
    Pfad=EntferneAnfuehrungszeichen(PfadListe)
    parcnt=ParNo
    Pfad=STRIP(Pfad,'T','\')
    Pdatei=Pfad'\'Pname

    DROP alt_liste.
    alt_liste.0=0
    IF (SucheDatei(Pdatei,'A')='Q') THEN LEAVE
    IF (SucheDatei(Pdatei'.COM','S')='Q') THEN LEAVE
    IF (SucheDatei(Pdatei'.EXE','S')='Q') THEN LEAVE
    IF (cmdshell='OS2.EXE') THEN
      IF (SucheDatei(Pdatei'.CMD','S')='Q') THEN LEAVE
    IF (SucheDatei(Pdatei'.CMD','S')='Q') THEN LEAVE
    IF (SucheDatei(Pdatei'.BAT','S')='Q') THEN LEAVE
  END
  DROP alt_liste.
  IF erfolg='N' THEN DO
    CALL error prog': '''Pname''' nicht gefunden in',
                             VALUE('PATH',,'OS2ENVIRONMENT')
  END
  RETURN

/*--------------------------------------------------------*/
/* ScanOptions dekodiert die bergebenen Optionen.        */
/*--------------------------------------------------------*/
ScanOptions: PROCEDURE EXPOSE alle lang ArgCnt prog
  alle='N'; lang='N'; ArgCnt=1
  argument=WORD(ARG(1),ArgCnt)

  IF (argument='?') THEN CALL usage

  DO WHILE (LEFT(argument,1)='-')
    i=2
    DO UNTIL (i>LENGTH(argument))
      ch=SUBSTR(argument,i,1)
      SELECT
        WHEN ch='a' THEN alle='J'
        WHEN ch='l' THEN lang='J'
        WHEN (ch='h') | (ch='?') THEN CALL usage
        OTHERWISE CALL syntax
      END
      i=i+1
    END
    ArgCnt=ArgCnt+1
    argument=WORD(ARG(1),ArgCnt)
  END

  IF (ArgCnt>1) & (argument='') THEN CALL syntax

  RETURN

/*--------------------------------------------------------*/
/* 'SucheAlias' sucht in den aliases von 4OS2 nach        */
/* passenden Eintrgen.                                   */
/*--------------------------------------------------------*/
SucheAlias: PROCEDURE EXPOSE erfolg lang alle prog
  PARSE ARG befehl

  '@alias 2>&1 | RXQUEUE'
  IF (rc=0) THEN DO
    DO QUEUED()
      PARSE PULL aliasbef'='alias
      IF (LEFT(aliasbef,1)\='@') THEN DO
        IF (match(aliasbef,befehl)='J') THEN DO
          erfolg='J'
          IF (lang='J') THEN
              SAY aliasbef,
                  LEFT(COPIES(' ',20),20-LENGTH(aliasbef)),
                  'Alias fr: 'alias
          ELSE
            SAY aliasbef
        END
      END
    END
  END
  ELSE
    PARSE PULL
  IF (erfolg='J') & (alle='N') THEN RETURN 'Q'
                                   /* Quit: Suche beenden */
  RETURN 'W' /* Weiter: Weiter suchen */

/*--------------------------------------------------------*/
/* 'SucheInternesKommando' sucht in 'intern.' nach        */
/* passenden Eintrgen.                                   */
/*--------------------------------------------------------*/
SucheInternesKommando: PROCEDURE EXPOSE intern. lang alle,
                                        erfolg cmdshell prog
  PARSE ARG befehl

  DO k=1 TO intern.0
    IF (match(intern.k,befehl)='J') THEN DO
      IF (lang='J') THEN
        SAY intern.k,
            LEFT(COPIES(' ',20),20-LENGTH(intern.k)),
            'interner OS/2 Befehl ('cmdshell')'
      ELSE
        SAY intern.k
      erfolg='J'
    END
  END

  IF (erfolg='J') & (alle='N') THEN RETURN 'Q'
                                   /* Quit: Suche beenden */
  RETURN 'W' /* Weiter: Weiter suchen */

/*--------------------------------------------------------*/
/* 'SucheVorhanden' schaut nach, ob der gleiche Dateiname */
/* schon einmal gefunden (d.h. ausgegeben) wurde.         */
/* Dies kann geschehen, wenn ein Name wie *c* angegeben   */
/* wurde, also:                                           */
/* 1) Dateiname mit Endung '.COM' oder '.CMD'             */
/* 2) Dateiname mit einem 'C' im Dateinamen               */
/* Z.B. wrde 'which.cmd' in diesem Fall zweimal gefunden.*/
/*--------------------------------------------------------*/
SucheVorhanden: PROCEDURE EXPOSE alt_liste. alle prog
  ARG eintrag, type

  IF (alle='J') THEN DO
    IF (type='S') THEN /* S=Search */
      DO v=1 TO alt_liste.0
        IF (alt_liste.v=eintrag) THEN
          RETURN 'J'
      END
    ELSE DO /* A=Add */
      alt_liste.0=alt_liste.0 + 1
      v=alt_liste.0
      alt_liste.v=eintrag
    END
  END

  RETURN 'N'

/*--------------------------------------------------------*/
/* 'SucheDatei' sucht mit SysFileTree nach passenden      */
/* Dateinamen und gibt diese, falls sie ausfhrbar sind,  */
/* im gewnschten Format auf StdOut aus.                  */
/*--------------------------------------------------------*/
SucheDatei:
  PARSE ARG name,type

  altes_LW=DIRECTORY()
  IF (SUBSTR(name,2,1)=':') & (POS('\',name)=0) THEN DO
    /* Funktioniert nicht richtig mit SysFileTree, das LW */
    /* mu gewechselt und der LW-Bezeichner entfernt      */
    /* werden, anschlieend LW wieder zurcksetzen.       */
    neues_LW=DIRECTORY(LEFT(name,2))
    name=RIGHT(name,LENGTH(name)-2)
  END

  ret=SysFileTree(name,found.,'F','*--**')
  IF (ret\=0) THEN DO
    CALL error prog': zu wenig Speicher.'
    EXIT 4
  END
  altes_LW=DIRECTORY(altes_LW)

  IF (found.0>0) THEN DO
    DO i=1 TO found.0
      datei=SUBWORD(found.i,5)

      /* Ausfhrbare Datei gefunden? */
      IF (POS('.',datei) \= 0) THEN DO
        /* Nur ausgeben, wenn noch nicht geschehen: */
        IF (SucheVorhanden(datei,type)='N') THEN DO
          erfolg='J'
          CALL AusgabeDateiname found.i, lang
        END
      END

    END
  END
  IF (erfolg='J') & (alle='N') THEN RETURN 'Q'
                                   /* Quit: Suche beenden */
  RETURN 'W' /* Weiter: Weiter suchen */

/*--------------------------------------------------------*/
/* AusgabeDateiname gibt die gefundene Datei im           */
/* gewnschten Format aus.                                */
/*--------------------------------------------------------*/
AusgabeDateiname: PROCEDURE EXPOSE prog
PARSE ARG name, lang

  IF (lang='J') THEN DO
    /* In deutsches Format umsetzen: */
    stde=SUBSTR(name,11,2)
    IF (SUBSTR(name,16,1)='p') & (stde\=12) THEN
       stde=stde+12
    datei=SUBSTR(name,4,2)'.'
    datei=datei''TRANSLATE(LEFT(name,2),'0',' ')
    datei=datei'.'SUBSTR(name,7,4)''stde'.'
    datei=datei''SUBSTR(name,14,2)''SUBSTR(name,17,19)
    /* Wenn Datei ohne SYS1059 Fehlermeldung ausfhrbar
       ist, ein '*' anfgen. */
    ext=TRANSLATE(RIGHT(name,4))
    SELECT
      WHEN (ext='.BAT') THEN datei=datei'?'
      WHEN (ext='.CMD') | (ext='.BTM') THEN datei=datei'*'
      OTHERWISE DO
          exec_start=CHARIN(SUBWORD(name,5),1,2)
          CALL CHAROUT SUBWORD(name,5) /* Datei schlieen */
          groesse=SUBWORD(name,3,1)
          IF (exec_start='MZ') & (groesse >= 64 ) THEN
            datei=datei'*'
          ELSE
            datei=datei' '
      END
    END
    SAY datei' 'SUBSTR(name,37)
  END
  ELSE /* Ausgabe des blanken Dateinamens */
    SAY SUBWORD(name,5)

  RETURN

/*--------------------------------------------------------*/
/* EntferneAnfuehrungszeichen erzeugt den blanken Datei=  */
/* namen aus Dateinamen in Anfhrungszeichen.             */
/*                                                        */
/* Parameter:                                             */
/*   ArgStr       Die gesamte Parameterzeichenkette.      */
/*                                                        */
/* Rckgabewert:                                          */
/*   name         Der Name ohne Anfhrungszeichen.        */
/*                                                        */
/* Globale Variablen:                                     */
/*   ParNo       Nummer des zu untersuchenden Parameters, */
/*               wird auf den nchsten Parameter gesetzt. */
/*   prog        Name des aufrufenden Programmes (zur     */
/*               Ausgabe von Fehlermeldungen)             */
/*--------------------------------------------------------*/
EntferneAnfuehrungszeichen: PROCEDURE EXPOSE ParNo prog
  PARSE ARG ArgStr

  name = SUBWORD(ArgStr,ParNo)
  first=POS('"',name)
  ende=POS(' ',name)
  IF (ende=0) THEN ende=LENGTH(name)+1

  IF (ende>first) & (first>0) THEN
    DO WHILE (first>0)
      name=DELSTR(name,first,1)
      second=POS('"',name)
      IF (second=0) THEN DO
        CALL error prog': fehlendes Anfhrungszeichen'
        EXIT 4
      END
      name=DELSTR(name,second,1)
      first=POS('"',name)
      ende=POS(' ',name,second)
      IF (ende=0) THEN ende=LENGTH(name)+1
      IF (ende<first) | (first=0) THEN DO
        name=DELSTR(name,ende)
        LEAVE
      END
    END
  ELSE
    name = WORD(ArgStr,ParNo)

  ParNo=ParNo+WORDS(name)
  RETURN name

/*--------------------------------------------------------*/
/* Prfung, ob sich zwei Zeichenketten entsprechen.       */
/* Nur s2 darf Wildcards ('?','*') enthalten.             */
/* Umlaute werden nicht bercksichtigt, d.h., nicht in    */
/* Grobuchstaben umgesetzt.                              */
/*--------------------------------------------------------*/
match: PROCEDURE EXPOSE prog
  ARG s1, s2

  IF (s1=s2) THEN RETURN 'J'
  IF ((POS('*',s2) + POS('?',s2))=0) THEN RETURN 'N'

  s1_length=LENGTH(s1)
  s2_length=LENGTH(s2)
  p1=1; p2=1

  DO FOREVER
    ch1=SUBSTR(s1,p1,1); ch2=SUBSTR(s2,p2,1)
    SELECT
      WHEN (ch1=ch2) | (ch2='?') THEN DO
        p1=p1+1; p2=p2+1
      END
      WHEN (ch2='*') THEN DO
        /* Wenn '*' ganz am Ende, dann ist match = 'J' */
        IF (p2=s2_length) THEN RETURN 'J'
        /* Sonst: rekursiv eine geeignete
                             Wiederaufnahmestelle suchen: */
        DO UNTIL (p1>s1_length)
          /* Mgliche Einsprungstelle suchen: */
          ch2=SUBSTR(s2,p2+1,1)
          IF ( (ch2\='*') & (ch2\='?') ) THEN
            DO WHILE ( (ch1\=ch2) & (p1<s1_length) )
              p1=p1+1; ch1=SUBSTR(s1,p1,1)
            END
          IF (p1=s1_length) & (ch1\=ch2) & (ch1\='*'),
                                & (ch1\='?') THEN RETURN 'N'
          /* Rekursiv weitersuchen: */
          ret=match(SUBSTR(s1,p1,s1_length-p1+1), ,
                         SUBSTR(s2,p2+1,s2_length-p2))
          IF (ret='J') THEN RETURN 'J'
          p1=p1+1; ch1=SUBSTR(s1,p1,1)
        END
      END
      OTHERWISE RETURN 'N'
    END
    IF (p1>s1_length) & (p2>s2_length) THEN RETURN 'J'
    IF (LENGTH(STRIP(s2,'T','*'))>s2_length) THEN RETURN 'N'
    IF (p1>s1_length) THEN DO
      s2=STRIP(s2,'T','*')
      IF (p2>LENGTH(s2)) THEN RETURN 'J'
      RETURN 'N'
    END
  END

/*--------------------------------------------------------*/
/* usage: Ausgabe eines Hilfetextes mit der Syntax.       */
/*--------------------------------------------------------*/
usage:
  SAY
  SAY
  SAY 'Aufruf: 'prog' [-?hal] [dateiname...]'
  SAY
  SAY '        -h, -? gibt diesen Hilfetext aus'
  SAY '        -a gibt ALLE passenden ausfhrbaren ',
                                               'Dateien aus'
  SAY '        -l Ausgabe im Langformat'
  SAY '        ohne dateinamen werden die Pfade in',
                                       '''PATH'' ausgegeben'
  EXIT 0

/*--------------------------------------------------------*/
/* syntax: Ausgabe der Aufrufsyntax.                      */
/*--------------------------------------------------------*/
syntax:
  CALL error 'Aufruf: 'prog' [-?hal] [dateiname...]'
  EXIT 4

/*--------------------------------------------------------*/
/* Textausgabe auf StdErr                                 */
/*--------------------------------------------------------*/
error: PROCEDURE EXPOSE prog
  PARSE ARG text
  CALL LINEOUT 'StdErr:', text
  RETURN

/*--------------------------------------------------------*/
/* ende: Endebehandlung.                                  */
/*--------------------------------------------------------*/
ende:
  CALL error prog': Programm abgebrochen...'
  DO QUEUED(); PARSE PULL; END
  EXIT 3
