(* ------------------------------------------------------ *)
(*                      EASYVIS.PAS                       *)
(*   Arbeiten mit Write und WriteLn unter Turbo Vision    *)
(*             (c) 1993 Wolfhard Rinke & DMV              *)
(* ------------------------------------------------------ *)
UNIT EasyVis;

{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}

INTERFACE

USES Objects, Views, App, Redir, MsgBox, Browser, StdDlg;

TYPE
  tEasyApp = OBJECT (tApplication)
    Error : WORD;

    CONSTRUCTOR Init;
    PROCEDURE   Browse(FileName : STRING; Open : BOOLEAN);
    PROCEDURE   Work; VIRTUAL;
    DESTRUCTOR  Done; VIRTUAL;
  END;

IMPLEMENTATION

CONST
  mfErrorBox : WORD = mfError + mfOkButton;

  PROCEDURE tEasyApp.Work;
  BEGIN
    WriteLn('Hello Turbo Vision!');
  END;

  CONSTRUCTOR tEasyApp.Init;
  VAR
    f : File;
  BEGIN
    inherited Init;

    Error := RedirectStdOut('STDOUT.RED');
    IF Error <> 0 THEN
      MessageBox(RedirectErrMsg(Error), NIL, mfErrorBox);

    Work;
    Browse('STDOUT.RED', TRUE);
    Assign(f, 'STDOUT.RED');
    Erase(f);
  END;

  PROCEDURE tEasyApp.Browse(FileName : STRING;
                            Open : BOOLEAN);
  VAR
    N : STRING;
    W : pWindow;
    R : tRect;
  BEGIN
    N := FileName;
    GetExtent(R);
    Dec(R.B.Y, 2);
    W := pWindow(ValidView(New(pFileWindow, Init(R, N))));
    IF W <> NIL THEN Desktop^.Insert(W);
  END;

  DESTRUCTOR tEasyApp.Done;
  BEGIN
    Error := RestoreStdOut;
    IF Error <> 0 THEN
      MessageBox(RedirectErrMsg(Error), NIL, mfErrorBox);

    inherited Done;
  END;

END.
(* ------------------------------------------------------ *)
(*                 Ende von EASYVIS.PAS                   *)
